#pragma once

#include "resource.h"

class DriverSetupData;

/**
 * DriverPropertyView
 */
class DriverPropertyView :
	public CDialogImpl<DriverPropertyView>
{
	DriverSetupData const &driver_data;

public:
	DriverPropertyView(DriverSetupData const &driver_data);

	enum { IDD = IDD_DRIVER_PROPERTY_VIEW };

	BEGIN_MSG_MAP_EX(DriverPropertyView)
		MSG_WM_INITDIALOG(OnInitDialog)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
};

class ScrollView :
	public CScrollWindowImpl<ScrollView>
{
	DriverPropertyView view;

public:
	ScrollView(DriverSetupData const &driver_data);

	BEGIN_MSG_MAP_EX(ScrollView)
		MSG_WM_CREATE(OnCreate)
		CHAIN_MSG_MAP(CScrollWindowImpl<ScrollView>)
		CHAIN_MSG_MAP_ALT(CScrollWindowImpl<ScrollView>, 1)
	END_MSG_MAP_EX()

	int OnCreate(CREATESTRUCT * /*create_struct*/);
	void DoPaint(CDCHandle /*dc*/);
};

/**
 * DriverPropertyDialog
 */
class DriverPropertyDialog :
	public CDialogImpl<DriverPropertyDialog>
{
	std::wstring const title;
	ScrollView view;

public:
	DriverPropertyDialog(std::wstring const &title, DriverSetupData const &driver_data);

	enum { IDD = IDD_DRIVER_PROPERTY_DIALOG };

	BEGIN_MSG_MAP_EX(DriverPropertyDialog)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER_EX(IDOK, OnCloseCmd)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnCloseCmd)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	void OnCloseCmd(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
};

/**
 * DriverReplaceDialog
 */
class DriverReplaceDialog :
	public CDialogImpl<DriverReplaceDialog>
{
	ScrollView view_exist;
	ScrollView view_new;

public:
	DriverReplaceDialog(DriverSetupData const &driver_data_exist, DriverSetupData const &driver_data_new);

	enum { IDD = IDD_DRIVER_REPLACE_DIALOG };

	BEGIN_MSG_MAP_EX(DriverReplaceDialog)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER_EX(IDOK, OnCloseCmd)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnCloseCmd)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	void OnCloseCmd(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
};
