#pragma once

class DriverSetupData;

// hCoꗗ\pXgr[

class ItemAssociatedData {
public:
	enum ItemState {
		NEWLY_ADDED,
		ADDED_BEFORE,
		ADDED_BEFORE_REMOVE
	};

	ItemAssociatedData(ItemState item_state, DriverSetupData const &item_data);
	~ItemAssociatedData();
	void setItemState(ItemState item_state);
	ItemState getItemState() const;
	DriverSetupData* getItemData() const;

private:
	ItemState item_state;
	DriverSetupData *item_data_ptr;
};

class DriversListViewCtrl :
	public CSortListViewCtrlImpl<DriversListViewCtrl>
{
public:
	DriversListViewCtrl();
	~DriversListViewCtrl();

	struct ItemAdditionCount {
		int add_count;
		int replace_count;
		ItemAdditionCount() : add_count(0), replace_count(0) {}
	};

	void setParameter(int architecture_id, uint32_t os_version);
	void setDeviceClassImageList();
	ItemAdditionCount addDriversListItems(std::vector<DriverSetupData> const &driver_data, wchar_t const *str = NULL);
	ItemAdditionCount addDriversFromFileOrDir(boost::filesystem::wpath const &path, wchar_t const *str = NULL);
	void removeSelectedItem();
	void showPropertyOfSelectdeItem();
	void showItemAdditionMessage(ItemAdditionCount add_count);

	void addIntegratedDrivers(boost::filesystem::wpath const &path);

	DECLARE_WND_SUPERCLASS(_T("DriversListViewCtrl__59D54726_5786_44F7_83D0_5A586F70F548"), GetWndClassName())

	BEGIN_MSG_MAP_EX(DriversListViewCtrl)
		MSG_WM_KEYDOWN(OnKeyDown)
		MSG_WM_DROPFILES(OnDropFiles)
		CHAIN_MSG_MAP(CSortListViewCtrlImpl<DriversListViewCtrl>)
	END_MSG_MAP_EX()

	void OnKeyDown(unsigned int /*nChar*/, unsigned int /*nRepCnt*/, unsigned int /*nFlags*/);
	void OnDropFiles(HDROP /*hDropInfo*/);

private:
	int architecture_id;
	uint32_t os_version;
	SP_CLASSIMAGELIST_DATA image_list_data;

	enum ItemAdditionResult {
		ITEM_ADDED,
		ITEM_REPLACED,
		NO_CHANGE
	};

	ItemAdditionResult addDriversListItem(DriverSetupData const &driver_data, wchar_t const *str = NULL);
	ItemAdditionResult addDriversListItemFromInfFile(boost::filesystem::wpath const &filename,
	                                                 int target_architecture,
	                                                 uint32_t target_version, wchar_t const *str = NULL);
	ItemAdditionCount addDriversFromDir(boost::filesystem::wpath const &path, wchar_t const *str = NULL);
	ItemAdditionResult checkDuplication(DriverSetupData const &driver_data);
};
