// F6ToolView.h : interface of the CF6ToolView class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include "resource.h"
#include "SourceSettingPage.h"
#include "SlipstreamSettingPage.h"
#include "OutputSettingPage.h"
#include "ConfirmationPage.h"
#include "ProgressPage.h"

class CF6ToolView :
	public CDialogImpl<CF6ToolView>,
	public CDialogResize<CF6ToolView>
{
	typedef CF6ToolView ThisType;

	HWND m_hWndFocus;
	int active_page_index;
	SourceSettingPage source_setting_page;
	SlipstreamSettingPage slipstream_setting_page;
	OutputSettingPage output_setting_page;
	ConfirmationPage confirmation_page;
	ProgressPage progress_page;
	CButton prev_button;
	CButton next_button;
	CButton finish_button;

public:
	enum { IDD = IDD_F6TOOL_FORM };
	enum {
		UWM_ENABLE_EXIT = WM_APP + 1,
		UWM_DISABLE_EXIT
	};

	CF6ToolView();
	BOOL SaveFocusControl();

	BOOL PreTranslateMessage(MSG* pMsg);

	BEGIN_DLGRESIZE_MAP(ThisType)
		DLGRESIZE_CONTROL(IDD_SOURCE_SETTING_PAGE, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDD_SLIPSTREAM_SETTING_PAGE, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(150, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDD_CONFIRMATION_PAGE, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDD_PROGRESS_PAGE, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDC_BORDER, DLSZ_MOVE_Y | DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_BUTTON_PREV, DLSZ_MOVE_X | DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDC_BUTTON_NEXT, DLSZ_MOVE_X | DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDC_BUTTON_FINISH, DLSZ_MOVE_X | DLSZ_MOVE_Y)
	END_DLGRESIZE_MAP()

	BEGIN_MSG_MAP_EX(ThisType)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_SETFOCUS(OnSetFocus)
		MSG_WM_ACTIVATE(OnActivate)
		COMMAND_HANDLER_EX(IDC_BUTTON_PREV, BN_CLICKED, OnButtonPrev)
		COMMAND_HANDLER_EX(IDC_BUTTON_NEXT, BN_CLICKED, OnButtonNext)
		COMMAND_HANDLER_EX(IDC_BUTTON_FINISH, BN_CLICKED, OnButtonFinish)
		MESSAGE_HANDLER_EX(ProgressPage::UWM_ENABLE_FINISH_BUTTON, OnEnableFinishButton)
		MESSAGE_HANDLER_EX(ProgressPage::UWM_ENABLE_BACK_BUTTON, OnEnableBackButton)
		MESSAGE_HANDLER_EX(DriverSettingPage::UWM_POPUP_MENU_SELECT, OnPopupMenuSelect)
		//MESSAGE_HANDLER_EX(DriverSettingPage::UWM_DRIVER_LIST_IMPORT, OnDriverListImport)
		//MESSAGE_HANDLER_EX(DriverSettingPage::UWM_DRIVER_LIST_EXPORT, OnDriverListExport)
		CHAIN_MSG_MAP(CDialogResize<ThisType>)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	void OnSetFocus(HWND /*wndOld*/);
	void OnActivate(unsigned int /*nState*/, BOOL /*bMinimized*/, HWND /*wndOther*/);
	void OnButtonPrev(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnButtonNext(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnButtonFinish(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	LRESULT OnEnableFinishButton(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
	LRESULT OnEnableBackButton(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
	LRESULT OnPopupMenuSelect(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
	//LRESULT OnDriverListImport(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
	//LRESULT OnDriverListExport(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
};
