// MainFrm.cpp : implmentation of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#include "aboutdlg.h"
#include "F6ToolView.h"
#include "MainFrm.h"
#include "mylib/inifile.h"

BOOL CMainFrame::PreTranslateMessage(MSG* pMsg)
{
	if(CFrameWindowImpl<CMainFrame>::PreTranslateMessage(pMsg))
	{
		return TRUE;
	}

	return m_view.PreTranslateMessage(pMsg);
}

BOOL CMainFrame::OnIdle()
{
	return FALSE;
}

int CMainFrame::OnCreate(CREATESTRUCT * /*lpCreateStruct*/)
{
#ifdef MY_DEBUG
	::WritePrivateProfileString(L"Debug", L"State", L"CMainFrame::OnCreate() start", PROFILE_PATH->string().c_str());
#endif

	CreateSimpleStatusBar();

	m_hWndClient = m_view.Create(m_hWnd);
	UISetCheck(ID_VIEW_STATUS_BAR, 1);

	// EBhETCYύXłŏTCY肷
	RECT status_bar_rect;
	::GetWindowRect(this->m_hWndStatusBar, &status_bar_rect);
	RECT view_rect;
	::GetWindowRect(this->m_hWndClient, &view_rect);
	RECT r;
	r.top = view_rect.top;
	r.left = view_rect.left;
	r.bottom = view_rect.top + (view_rect.bottom - view_rect.top) + (status_bar_rect.bottom - status_bar_rect.top);
	r.right = view_rect.right;
	::AdjustWindowRectEx(&r, GetStyle(), (!(GetStyle() & WS_CHILD) && (GetMenu() != NULL)), GetExStyle());
	this->min_size.x = r.right - r.left;
	this->min_size.y = r.bottom - r.top;

	// EBhETCY̓ǂݍ
	IniFile ini_file(*PROFILE_PATH);
	POINT p;
	p.x = ini_file.getInt(L"Settings", L"x", 0);
	p.y = ini_file.getInt(L"Settings", L"y", 0);
	SIZE s;
	s.cx = ini_file.getInt(L"Settings", L"cx", this->min_size.x);
	s.cy = ini_file.getInt(L"Settings", L"cy", this->min_size.y);
	CRect rcWnd(p, s);
	// Ώۃj^̏擾
	HMONITOR hMonitor = MonitorFromRect(
		&rcWnd, MONITOR_DEFAULTTONEAREST);
	MONITORINFO mi;
	mi.cbSize = sizeof(mi);
	GetMonitorInfo(hMonitor, &mi);
	// ʒu␳
	if (rcWnd.right > mi.rcMonitor.right) {
		rcWnd.left -= rcWnd.right - mi.rcMonitor.right;
		rcWnd.right = mi.rcMonitor.right;
	}
	if (rcWnd.left < mi.rcMonitor.left) {
		rcWnd.right += mi.rcMonitor.left - rcWnd.left;
		rcWnd.left = mi.rcMonitor.left;
	}
	if (rcWnd.bottom > mi.rcMonitor.bottom) {
		rcWnd.top -= rcWnd.bottom - mi.rcMonitor.bottom;
		rcWnd.bottom = mi.rcMonitor.bottom;
	}
	if (rcWnd.top < mi.rcMonitor.top) {
		rcWnd.bottom += mi.rcMonitor.top - rcWnd.top;
		rcWnd.top = mi.rcMonitor.top;
	}
	this->SetWindowPos(NULL, rcWnd, SWP_NOZORDER);

	this->is_exit_enabled = true;

	// register object for message filtering and idle updates
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	ATLASSERT(pLoop != NULL);
	pLoop->AddMessageFilter(this);
	pLoop->AddIdleHandler(this);

#ifdef MY_DEBUG
	::WritePrivateProfileString(L"Debug", L"State", L"CMainFrame::OnCreate() end", PROFILE_PATH->string().c_str());
#endif
	return 0;
}

void CMainFrame::OnClose()
{
	if (this->is_exit_enabled) {
		int const ret = this->MessageBox(L"I܂", L"F6c[",
			MB_OKCANCEL | MB_ICONQUESTION |MB_DEFBUTTON2);
		if (ret == IDOK) {
			this->DestroyWindow();
		}
	}
}

void CMainFrame::OnDestroy()
{
	// EBhETCY̕ۑ
	IniFile ini_file(*PROFILE_PATH);
	WINDOWPLACEMENT wnd_place;
	wnd_place.length = sizeof(wnd_place);
	this->GetWindowPlacement(&wnd_place);
	CRect r(wnd_place.rcNormalPosition);
	ini_file.setInt(L"Settings", L"x", r.left);
	ini_file.setInt(L"Settings", L"y", r.top);
	ini_file.setInt(L"Settings", L"cx", r.Width());
	ini_file.setInt(L"Settings", L"cy", r.Height());

	// unregister message filtering and idle updates
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	ATLASSERT(pLoop != NULL);
	pLoop->RemoveMessageFilter(this);
	pLoop->RemoveIdleHandler(this);

	this->SetMsgHandled(false);
}

void CMainFrame::OnGetMinMaxInfo(MINMAXINFO *lpMMI)
{
	lpMMI->ptMinTrackSize = this->min_size;
}

void CMainFrame::OnActivate(unsigned int nState, BOOL /*bMinimized*/, HWND /*wndOther*/)
{
	if (nState == WA_INACTIVE) {
		m_view.SaveFocusControl();     // save focus when frame loses activation
	}
}

void CMainFrame::OnSysCommand(unsigned int nID, CPoint /*lParam*/)
{
	if ((nID & 0xfff0) == SC_MINIMIZE) {
		//this->m_view.SendMessage(WM_SAVEFOCUS);
		m_view.SaveFocusControl();
	}
	SetMsgHandled(false);
}

LRESULT CMainFrame::OnEnableExit(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	this->is_exit_enabled = true;
	return 0;
}

LRESULT CMainFrame::OnDisableExit(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	this->is_exit_enabled = false;
	return 0;
}

void CMainFrame::OnFileExit(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/)
{
	PostMessage(WM_CLOSE);
}

//void CMainFrame::OnDriverListImport(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/)
//{
//	this->m_view.PostMessage(DriverSettingPage::UWM_DRIVER_LIST_IMPORT);
//}
//
//void CMainFrame::OnDriverListExport(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/)
//{
//	this->m_view.PostMessage(DriverSettingPage::UWM_DRIVER_LIST_EXPORT);
//}

void CMainFrame::OnViewStatusBar(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/)
{
	BOOL bVisible = !::IsWindowVisible(m_hWndStatusBar);
	::ShowWindow(m_hWndStatusBar, bVisible ? SW_SHOWNOACTIVATE : SW_HIDE);
	UISetCheck(ID_VIEW_STATUS_BAR, bVisible);
	UpdateLayout();
}

void CMainFrame::OnAppAbout(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/)
{
	CAboutDlg dlg;
	dlg.DoModal();
}
