#pragma once

#include "resource.h"
#include "mylib/multicastpattern.h"

class SourceSetting;
class SlipstreamSetting;
class OutputSetting;

class ProgressPage :
	public CDialogImpl<ProgressPage>,
	public CDialogResize<ProgressPage>,
	public MyLib::EventListener<std::wstring>
{
	typedef ProgressPage ThisType;

	SourceSetting const *source_setting;
	SlipstreamSetting const *slipstream_setting;
	OutputSetting const *output_setting;
	CEdit edit1;

protected:
	void eventHappened(std::wstring const &arg);

public:
	enum { IDD = IDD_PROGRESS_PAGE };
	enum {
		UWM_ENABLE_FINISH_BUTTON = WM_APP + 0x10,
		UWM_ENABLE_BACK_BUTTON
	};

	ProgressPage();
	~ProgressPage();

	void loadSettings(SourceSetting const *source_setting,
	                  SlipstreamSetting const *slipstream_setting,
	                  OutputSetting const *output_setting);

	static unsigned int WINAPI threadMain(void *param);

	BEGIN_DLGRESIZE_MAP(ThisType)
		DLGRESIZE_CONTROL(IDC_EDIT1, DLSZ_SIZE_X | DLSZ_SIZE_Y)
	END_DLGRESIZE_MAP()

	BEGIN_MSG_MAP_EX(ThisType)
		MSG_WM_INITDIALOG(OnInitDialog)
		MESSAGE_HANDLER_EX(UWM_ENABLE_FINISH_BUTTON, OnEnableFinishButton)
		MESSAGE_HANDLER_EX(UWM_ENABLE_BACK_BUTTON, OnEnableBackButton)
		CHAIN_MSG_MAP(CDialogResize<ThisType>)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	LRESULT OnEnableFinishButton(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
	LRESULT OnEnableBackButton(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
};

