#pragma once

#include "resource.h"

class SourceSetting;

struct RecordSetting
{
	//bool saves_iso_image;
	//bool writes_to_disc;
	std::wstring volume_label;
	boost::filesystem::wpath iso_image_path;
	std::wstring record_device;
	int record_speed;
	bool erases_media;
	bool ejects_media;
};

class RecordSettingPage :
	public CDialogImpl<RecordSettingPage>,
	public CDialogResize<RecordSettingPage>,
	public MyWinDataExchange<RecordSettingPage>
{
	typedef RecordSettingPage ThisType;

	bool erases_media_default;
	bool ejects_media_default;
	int record_speed_default;

	bool is_save_iso_checked;
	bool is_record_checked;
	std::wstring iso_path;
	std::wstring volume_label;
	bool erases_media;
	bool ejects_media;
	//CButton save_iso_checkbox;
	CStatic iso_path_label;
	CEdit iso_path_edit;
	CButton iso_path_button;
	//CButton record_checkbox;
	CStatic record_drive_label;
	CComboBox record_drive_list;
	CButton reload_button;
	CStatic record_speed_label;
	CEdit record_speed_edit;
	CUpDownCtrl record_speed_updown;
	CStatic record_speed2_label;
	CButton erase_media_checkbox;
	CButton eject_media_checkbox;
	CStatic volume_label_label;
	CEdit volume_label_edit;

	void switchControls();
	void enableControl(int control_id, bool enables);

public:
	enum { IDD = IDD_RECORD_SETTING_PAGE };

	RecordSettingPage();
	RecordSetting* getSetting();
	void loadSourceSetting(SourceSetting const *source_setting);
	void enumerateRecorders();

	BEGIN_DDX_MAP(ThisType)
		DDX_CHECK(IDC_CHECKBOX_SAVE_ISO, is_save_iso_checked)
		DDX_CHECK(IDC_CHECKBOX_RECORD, is_record_checked)
		DDX_TEXT(IDC_EDIT_FILE, iso_path)
		DDX_TEXT(IDC_EDIT_VOLUME_LABEL, volume_label)
		DDX_CHECK(IDC_CHECKBOX_ERASE_MEDIA, erases_media)
		DDX_CHECK(IDC_CHECKBOX_EJECT_MEDIA, ejects_media)
	END_DDX_MAP()

	BEGIN_DLGRESIZE_MAP(ThisType)
		DLGRESIZE_CONTROL(IDC_EDIT_FILE, DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_BUTTON_FILE, DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_COMBO_RECORD_DRIVE, DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_BUTTON_RELOAD, DLSZ_MOVE_X)
	END_DLGRESIZE_MAP()

	BEGIN_MSG_MAP_EX(ThisType)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_HANDLER_EX(IDC_CHECKBOX_SAVE_ISO, BN_CLICKED, OnCheckboxSaveIso)
		COMMAND_HANDLER_EX(IDC_CHECKBOX_RECORD, BN_CLICKED, OnCheckboxRecord)
		COMMAND_HANDLER_EX(IDC_BUTTON_FILE, BN_CLICKED, OnButtonFile)
		COMMAND_HANDLER_EX(IDC_BUTTON_RELOAD, BN_CLICKED, OnButtonReload)
		COMMAND_HANDLER_EX(IDC_EDIT_RECORD_SPEED, EN_CHANGE, OnEnChangeEditRecordSpeed)
		CHAIN_MSG_MAP(CDialogResize<ThisType>)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	void OnCheckboxSaveIso(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnCheckboxRecord(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnButtonFile(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnButtonReload(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnEnChangeEditRecordSpeed(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
};

