﻿#pragma once

#include "resource.h"
#include "GroupBox.h"

class SourceSetting;

struct SPSetting
{
	boost::filesystem::wpath sp_file_path;
	bool uses_bigdrive_w2k;
	bool is_clean_install_only;
	bool executes_driver_cab_recompress;
};

class SPSettingPage :
	public CDialogImpl<SPSettingPage>,
	public CDialogResize<SPSettingPage>,
	public CWinDataExchange<SPSettingPage>
{
	typedef SPSettingPage ThisType;

	//CStatic current_sp_number;
	CEdit   sp_file_box;
	CButton open_file_button;
	CButton big_drive_checkbox;
	CButton clean_install_only_checkbox;
	CButton recompress_driver_cab_checkbox;
	GroupBox groupbox_sp, groupbox_bigdrive, groupbox_clean_install_only;
	//int current_sp_number;
	//uint32_t os_version;

	wchar_t sp_file_path[MAX_PATH + 1];
	bool uses_bigdrive_w2k;
	bool clean_install_only_default;
	bool driver_cab_recompress_default;
	bool clean_install_only;
	bool driver_cab_recompress;

public:
	enum { IDD = IDD_SP_SETTING_PAGE };

	SPSettingPage();

	void loadSourceSetting(SourceSetting const *source_setting);
	SPSetting* getSetting();

	BOOL PreTranslateMessage(MSG *pMsg);

	BEGIN_DDX_MAP(ThisType)
		DDX_TEXT_LEN(IDC_EDIT_FILE, sp_file_path, MAX_PATH)
		DDX_CHECK(IDC_CHECKBOX_BIGDRIVE, uses_bigdrive_w2k)
		DDX_CHECK(IDC_CHECKBOX_CLEAN_INSTALL_ONLY, clean_install_only)
		DDX_CHECK(IDC_CHECKBOX_DRIVER_CAB_RECOMPRESS, driver_cab_recompress)
	END_DDX_MAP()

	BEGIN_DLGRESIZE_MAP(ThisType)
		DLGRESIZE_CONTROL(IDC_GROUPBOX_SP, DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_EDIT_FILE, DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_BUTTON_FILE, DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_GROUPBOX_BIGDRIVE, DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_GROUPBOX_CLEAN_INSTALL_ONLY, DLSZ_SIZE_X)
	END_DLGRESIZE_MAP()

	BEGIN_MSG_MAP_EX(ThisType)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_HANDLER_EX(IDC_BUTTON_FILE, BN_CLICKED, OnButtonFile)
		CHAIN_MSG_MAP(CDialogResize<SPSettingPage>)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	void OnButtonFile(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
};

