#pragma once

#include "resource.h"
#include "WorkDirSettingPage.h"
#include "SPSettingPage.h"
#include "DriverSettingPage.h"
//#include "UnattendSettingPage.h"

class SourceSetting;
class SlipstreamSetting;

class SlipstreamSettingPage :
	public CDialogImpl<SlipstreamSettingPage>,
	public CDialogResize<SlipstreamSettingPage>
	//public CWinDataExchange<SlipstreamSettingPage>
{
	typedef SlipstreamSettingPage ThisType;

	enum {
		TAB_PAGE_WORK_DIR_SETTING,
		TAB_PAGE_SP_SETTING,
		TAB_PAGE_DRIVER_SETTING,
		NUM_TAB_PAGES
	};

	CTabCtrl tab_ctrl;
	std::vector<CWindow*> tab_pages;
	WorkDirSettingPage work_dir_setting_page;
	SPSettingPage sp_setting_page;
	DriverSettingPage driver_setting_page;
//	UnattendSettingPage unattend_setting_page;

	void showTabPage(unsigned int page_index);
	void setCurrentTabPage(unsigned int page_index);

public:
	enum { IDD = IDD_SLIPSTREAM_SETTING_PAGE };

	SlipstreamSetting* getSetting();
	void loadSourceSetting(SourceSetting const *source_setting);
	BOOL PreTranslateMessage(MSG *pMsg);

	//BEGIN_DDX_MAP(ThisType)
	//	
	//END_DDX_MAP()

	BEGIN_DLGRESIZE_MAP(ThisType)
		DLGRESIZE_CONTROL(IDC_TAB1, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDD_WORK_DIR_SETTING_PAGE, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDD_SP_SETTING_PAGE, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDD_DRIVER_SETTING_PAGE, DLSZ_SIZE_X | DLSZ_SIZE_Y)
	END_DLGRESIZE_MAP()

	BEGIN_MSG_MAP_EX(ThisType)
		MSG_WM_INITDIALOG(OnInitDialog)
		NOTIFY_HANDLER_EX(IDC_TAB1, TCN_SELCHANGE, OnTcnSelchangeTab1)
		MESSAGE_HANDLER_EX(DriverSettingPage::UWM_POPUP_MENU_SELECT, OnPopupMenuSelect)
		//MESSAGE_HANDLER_EX(DriverSettingPage::UWM_DRIVER_LIST_IMPORT, OnDriverListImport)
		//MESSAGE_HANDLER_EX(DriverSettingPage::UWM_DRIVER_LIST_EXPORT, OnDriverListExport)
		CHAIN_MSG_MAP(CDialogResize<ThisType>)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	LRESULT OnTcnSelchangeTab1(LPNMHDR /*pnmh*/);
	LRESULT OnPopupMenuSelect(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
	//LRESULT OnDriverListImport(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
	//LRESULT OnDriverListExport(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
};

