﻿#pragma once

#include "resource.h"
//#include "core/SourceSetting.h"
class SourceSetting;

class SourceSettingPage :
	public CDialogImpl<SourceSettingPage>,
	public CDialogResize<SourceSettingPage>,
	public CWinDataExchange<SourceSettingPage>
{
	typedef SourceSettingPage ThisType;

	// CDドライブ変更通知用メッセージ
	enum { UWM_CHANGE_NOTIFY = WM_APP + 1 };

	int radio1;
	// CDドライブの一覧表示用ドロップダウンリスト
	CComboBoxEx cd_drive_list;
	// ドライブ一覧の更新ボタン
	CButton reload_button;
	// フォルダのパス入力用テキストボックス
	CEdit folder_box;

	// コンボボックスにCDドライブを列挙する
	void enumerateCDDrives(/*int drive_selection*/);
	// ラジオボタンの選択によって、各コントロールの切り替えを行う
	void switchControlsByRadioButton(int radio_button_id);

public:
	enum { IDD = IDD_SOURCE_SETTING_PAGE };

	SourceSetting* getSetting();

	BEGIN_DDX_MAP(ThisType)
		DDX_RADIO(IDC_RADIO_CD, radio1)
	END_DDX_MAP()

	BEGIN_DLGRESIZE_MAP(ThisType)
		DLGRESIZE_CONTROL(IDC_LIST_DRIVE, DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_BUTTON_RELOAD, DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_EDIT_FOLDER, DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_BUTTON_FOLDER, DLSZ_MOVE_X)
	END_DLGRESIZE_MAP()

	BEGIN_MSG_MAP_EX(ThisType)
		MSG_WM_INITDIALOG(OnInitDialog)
		MESSAGE_HANDLER_EX(UWM_CHANGE_NOTIFY, OnChangeNotify)
		COMMAND_HANDLER_EX(IDC_RADIO_CD, BN_CLICKED, OnRadioCd)
		COMMAND_HANDLER_EX(IDC_RADIO_FOLDER, BN_CLICKED, OnRadioFolder)
		COMMAND_HANDLER_EX(IDC_RADIO_PREINSTALL, BN_CLICKED, OnRadioPreinstall)
		COMMAND_HANDLER_EX(IDC_BUTTON_FOLDER, BN_CLICKED, OnButtonFolder)
		COMMAND_HANDLER_EX(IDC_BUTTON_RELOAD, BN_CLICKED, OnButtonReload)
		CHAIN_MSG_MAP(CDialogResize<ThisType>)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	LRESULT OnChangeNotify(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
	void OnRadioCd(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnRadioFolder(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnRadioPreinstall(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnButtonFolder(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnButtonReload(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
};

