// F6Tool.cpp : main source file for F6Tool.exe
//

#include "F6ToolView.h"
#include "MainFrm.h"

CAppModule _Module;

namespace {
boost::filesystem::wpath* getProfilePath()
{
	namespace fs = boost::filesystem;

	wchar_t module_file_name[MAX_PATH + 1];
	::GetModuleFileName(NULL, module_file_name, MAX_PATH);
	fs::wpath module_dir_tmp = module_file_name;

	fs::wpath result = fs::change_extension(module_dir_tmp, L".ini");
	return new fs::wpath(result);
}
boost::filesystem::wpath* getBinDirPath()
{
	namespace fs = boost::filesystem;

	wchar_t module_file_name[MAX_PATH + 1];
	::GetModuleFileName(NULL, module_file_name, MAX_PATH);
	fs::wpath module_dir_tmp = module_file_name;

	fs::wpath result = module_dir_tmp.remove_filename();
	result /= L"bin";
	return new fs::wpath(result);
}
};
boost::filesystem::wpath const *PROFILE_PATH = NULL;//getProfilePath();
boost::filesystem::wpath const *BIN_DIR_PATH = NULL;//getBinDirPath();

int Run(LPTSTR /*lpstrCmdLine*/ = NULL, int nCmdShow = SW_SHOWDEFAULT)
{
#ifdef MY_DEBUG
	::WritePrivateProfileString(L"Debug", L"State", L"Run() start", PROFILE_PATH->string().c_str());
#endif

	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);

	CMainFrame wndMain;

	if(wndMain.CreateEx() == NULL)
	{
		ATLTRACE(_T("Main window creation s܂!\n"));
		return 0;
	}

	wndMain.ShowWindow(nCmdShow);

#ifdef MY_DEBUG
	::WritePrivateProfileString(L"Debug", L"State", L"Run() end", PROFILE_PATH->string().c_str());
#endif

	int nRet = theLoop.Run();

	_Module.RemoveMessageLoop();
	return nRet;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
#ifdef MY_DEBUG
	::WritePrivateProfileString(L"Debug", L"State", L"0", PROFILE_PATH->string().c_str());
#endif

	PROFILE_PATH = getProfilePath();
	BIN_DIR_PATH = getBinDirPath();

	// ݃OIĂ郆[UǗҌĂȂꍇ̌xbZ[W
	if (!::IsUserAnAdmin()) {
		::MessageBox(NULL, L"̃\tgEFAgpɂ͊ǗҌKvłB", L"F6c[", MB_OK | MB_ICONEXCLAMATION);
		return EXIT_FAILURE;
	}

	HRESULT hRes = ::CoInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

	// this resolves ATL window thunking problem when Microsoft Layer for Unicode (MSLU) is used
	::DefWindowProc(NULL, 0, 0, 0L);

	AtlInitCommonControls(ICC_COOL_CLASSES | ICC_WIN95_CLASSES | ICC_USEREX_CLASSES | ICC_BAR_CLASSES);	// add flags to support other controls

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	::CoUninitialize();

	return nRet;
}
