﻿#pragma once

#include "resource.h"

class SourceSetting;

struct WorkDirSetting
{
	//WorkDirSetting(boost::filesystem::wpath const &work_dir_path,
	//               bool creates_temp_dir)
	//: work_dir_path(work_dir_path)
	//, creates_temp_dir(creates_temp_dir)
	//{
	//}

	boost::filesystem::wpath work_dir_path;
	bool creates_temp_dir;
};

class WorkDirSettingPage :
	public CDialogImpl<WorkDirSettingPage>,
	public CDialogResize<WorkDirSettingPage>,
	public MyWinDataExchange<WorkDirSettingPage>
{
	typedef WorkDirSettingPage ThisType;

	CEdit folder_box;
	CButton folder_button;
	CButton no_work_dir_checkbox;
	CButton temp_work_dir_checkbox;
	CListViewCtrl free_space_list;
	bool is_source_read_only;

	std::wstring dir_path;
	bool no_work_dir;
	bool temp_work_dir;

public:
	enum { IDD = IDD_WORK_DIR_SETTING_PAGE };

	WorkDirSettingPage();

	void loadSourceSetting(SourceSetting const *source_setting);
	//boost::filesystem::wpath* getSetting();
	WorkDirSetting* getSetting();

	BOOL PreTranslateMessage(MSG *pMsg);

	BEGIN_DDX_MAP(ThisType)
		DDX_TEXT(IDC_EDIT_FOLDER, dir_path)
		DDX_CHECK(IDC_CHECKBOX_NO_WORK_DIR, no_work_dir)
		DDX_CHECK(IDC_CHECKBOX_TEMP_WORK_DIR, temp_work_dir)
	END_DDX_MAP()

	BEGIN_DLGRESIZE_MAP(ThisType)
		DLGRESIZE_CONTROL(IDC_EDIT_FOLDER, DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_BUTTON_FOLDER, DLSZ_MOVE_X)
	END_DLGRESIZE_MAP()

	BEGIN_MSG_MAP_EX(ThisType)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_HANDLER_EX(IDC_BUTTON_FOLDER, BN_CLICKED, OnButtonFolder)
		COMMAND_HANDLER_EX(IDC_CHECKBOX_NO_WORK_DIR, BN_CLICKED, OnCheckboxNoWorkDir)
		COMMAND_HANDLER_EX(IDC_CHECKBOX_TEMP_WORK_DIR, BN_CLICKED, OnCheckboxTempWorkDir)
		CHAIN_MSG_MAP(CDialogResize<ThisType>)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	void OnButtonFolder(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnCheckboxNoWorkDir(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnCheckboxTempWorkDir(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
};

