#include "DiscRecorder.h"
#include "mylib/inifile.h"
#include "mylib/function.h"
#include "mylib/ConsoleProcessExecutor.h"

extern void stringReplace(std::wstring *str,
                          std::wstring const &find_str,
                          std::wstring const &replace_str);

DiscRecorder::DiscRecorder(std::wstring const &record_device_str,
                           int record_speed,
                           bool erases_rw_media,
                           bool ejects_media,
                           boost::filesystem::wpath const &iso_image_path)
{
	// CDĂ
	// cdrecord.exe ̃tpX擾
	namespace fs = boost::filesystem;
	fs::wpath const cdrecord_exe_path = *BIN_DIR_PATH/L"cdrecord.exe";
	//if (!fs::exists(cdrecord_exe_path)) {
		//throw
	//}
	// cdrecord.exe ̃IvVXCb`INIt@Cǂݏo
	IniFile ini_file(*PROFILE_PATH);
	std::wstring options = ini_file.getString(L"Settings", L"cdrecord_options", L"");
	if (options.empty()) {
		options = L"dev=SPTI: dev=\"##DEVICE##\" -v gracetime=3 speed=\"##SPEED##\" fs=32m -dao driveropts=burnfree \"##ISO_IMAGE##\"";
		ini_file.setString(L"Settings", L"cdrecord_options", options);
	}
	stringReplace(&options, L"##DEVICE##", record_device_str.substr(0, 5));
	std::wostringstream ss;
	ss << record_speed;
	stringReplace(&options, _T("##SPEED##"), ss.str());
	if (erases_rw_media) {
		if (options.find(L"blank=") == std::wstring::npos) {
			options = L"blank=fast " + options;
		}
	} else {
		// "blank=" 폜
		std::wstring::size_type pos = options.find(L"blank=");
		while (pos != std::wstring::npos) {
			std::wstring::size_type end_pos = options.find(L' ', pos);
			if (end_pos == std::wstring::npos) {
				end_pos = options.length();
			}
			options.replace(pos, end_pos - pos, L"");
			pos = options.find(L"blank=", end_pos);
		}
	}
	if (ejects_media) {
		if (options.find(L"-eject") == std::wstring::npos) {
			options = L"-eject " + options;
		}
	} else {
		stringReplace(&options, L"-eject", L"");
	}
	stringReplace(&options, L"##ISO_IMAGE##", iso_image_path.string());
	this->cmdline_ = L"\"" + cdrecord_exe_path.string() + L"\" " + options;
}

DiscRecorder::~DiscRecorder()
{
}

void DiscRecorder::execute()
{
	// R}hC\
	this->fireEvent(this->cmdline_ + L'\n');
	// cdrecord.exe N
	MyLib::ConsoleProcessExecutor cdrecord_exe;
	cdrecord_exe.run(this->cmdline_);
	unsigned int status;
	while ((status = cdrecord_exe.getStatus(100)) != WAIT_ABANDONED) {
		std::vector<char> buf = cdrecord_exe.readStdOut();
		if (!buf.empty()) {
			buf.push_back('\0');
			this->fireEvent(MyLib::convertFromSJIS(&buf[0]));
		}
		buf = cdrecord_exe.readStdErr();
		if (!buf.empty()) {
			buf.push_back('\0');
			this->fireEvent(MyLib::convertFromSJIS(&buf[0]));
		}
		if (status == WAIT_OBJECT_0) break;
	}
	const unsigned int exit_code = cdrecord_exe.getExitCode();
	if (exit_code != 0) {
		char buf[64];
		::wsprintfA(buf, "cdrecord.exe returned %d.", exit_code);
		throw std::runtime_error(buf);
	}
}
