#pragma once

#include "workstage.h"
#include "DriverSetupData.h"
#include "DriverFileData.h"
#include "DriverServiceData.h"

class DriverSlipStream :
	public WorkStage
{
public:
	DriverSlipStream(std::vector<DriverSetupData> add_drivers,
	                 DriverFileDataMap const &leave_drivers,
	                 DriverFileDataMap const &del_drivers,
	                 DriverServiceData const &leave_services,
	                 DriverServiceData const &del_services,
	                 wchar_t reserved_drive,
	                 bool adapts_big_drive,
	                 bool recompresses_driver_cab,
	                 boost::filesystem::wpath const &work_dir_path,
	                 std::wstring const &i386_subdir_name,
	                 int architecture_id,
	                 uint32_t os_version);

	virtual void execute();

protected:
	std::vector<DriverSetupData> add_drivers_;
	DriverFileDataMap leave_drivers_;
	DriverFileDataMap del_drivers_;
	DriverServiceData leave_services_;
	DriverServiceData del_services_;
	wchar_t reserved_drive;
	bool adapts_big_drive_;
	bool recompresses_driver_cab_;
	boost::filesystem::wpath work_dir_path_;
	std::wstring i386_subdir_name_;
	int architecture_id_;
	uint32_t os_version_;
};

