#include "OutputSetting.h"

OutputSetting::OutputSetting(std::wstring const &volume_label,
                             boost::filesystem::wpath const &iso_image_path,
                             std::wstring const &record_device,
                             int record_speed,
                             bool erases_media,
                             bool ejects_media,
                             wchar_t reserved_drive,
                             wchar_t usb_target_drive,
                             wchar_t usb_setup_drive)
: volume_label(volume_label)
, iso_image_path(iso_image_path)
, record_device(record_device)
, record_speed(record_speed)
, erases_media(erases_media)
, ejects_media(ejects_media)
, reserved_drive(reserved_drive)
, usb_target_drive(usb_target_drive)
, usb_setup_drive(usb_setup_drive)
{
}

OutputSetting::~OutputSetting(void)
{
}

std::wstring OutputSetting::getVolumeLabel() const
{
	return this->volume_label;
}

boost::filesystem::wpath OutputSetting::getISOImagePath() const
{
	return this->iso_image_path;
}

std::wstring OutputSetting::getRecordDevice() const
{
	return this->record_device;
}

int OutputSetting::getRecordSpeed() const
{
	return this->record_speed;
}

bool OutputSetting::erasesMedia() const
{
	return this->erases_media;
}

bool OutputSetting::ejectsMedia() const
{
	return this->ejects_media;
}

wchar_t OutputSetting::getReservedDrive() const
{
	return this->reserved_drive;
}

wchar_t OutputSetting::getUSBTargetDrive() const
{
	return this->usb_target_drive;
}

wchar_t OutputSetting::getUSBSetupDrive() const
{
	return this->usb_setup_drive;
}
