#include "ServicePackSlipStream.h"
#include "TemporaryDirectory.h"

#include "mylib/function.h"
#include "mylib/OtherProcessExecutor.h"
#include "mylib/FileCompressionInfo.h"

extern void deleteDirectory(boost::filesystem::wpath const &dir_path);
extern void removeFileForcibly(boost::filesystem::wpath const &file_path);
extern void moveFileOrDirUsingWildCards(boost::filesystem::wpath const &src_path,
                                        boost::filesystem::wpath const &dst_dir_path);

ServicePackSlipStream::ServicePackSlipStream(boost::filesystem::wpath const &sp_file_path,
                                             uint32_t os_version,
                                             std::wstring const &setup_subdir_name,
                                             boost::filesystem::wpath const &temp_dir_path,
                                             boost::filesystem::wpath const &target_dir_path)
	: sp_file_path_(sp_file_path)
	, os_version_(os_version)
	, setup_subdir_name_(setup_subdir_name)
	, temp_dir_path_(temp_dir_path)
	, target_dir_path_(target_dir_path)
{
}

ServicePackSlipStream::~ServicePackSlipStream(void)
{
}

void ServicePackSlipStream::execute()
{
	namespace fs = boost::filesystem;

	// 𓀐ꎞfBNg쐬
	TemporaryDirectoryCloseDelete temp_dir_close_delete;
	TemporaryDirectory sp_temp_dir(this->temp_dir_path_, &temp_dir_close_delete);
	fs::wpath const temp_dir_path = sp_temp_dir.getDirectoryPath();
	this->fireEvent(L"Service Pack KpĂ܂BBB");
	// SPt@C̓WJ
	MyLib::OtherProcessExecutor sp_file;
	sp_file.run(this->sp_file_path_.string() + _T(" /Q /X:\"") + temp_dir_path.string() + _T("\""));
	sp_file.getStatus(INFINITE);
	unsigned int sp_file_exit_code = sp_file.getExitCode();
	if (sp_file_exit_code != 0) {
		char buf[64];
		::wsprintfA(buf, "SP File returned %d.", sp_file_exit_code);
		throw std::runtime_error(buf);
	}
	// setupapi.dll̍폜(XP 32bit ̂)
	if (this->os_version_ == 0x00050001) {
		removeFileForcibly(temp_dir_path/L"i386\\update\\setupapi.dll");
	}
	// ꂩ폜t@CꎞIɕۊǂfBNg쐬
	TemporaryDirectoryCloseUndoMovedFiles temp_dir_close_undo_root(this->target_dir_path_);
	TemporaryDirectory old_sp_files_dir_root(this->temp_dir_path_, &temp_dir_close_undo_root);
	fs::wpath const old_sp_files_dir_root_path = old_sp_files_dir_root.getDirectoryPath();
	fs::wpath const i386_dir_path = this->target_dir_path_/this->setup_subdir_name_;
	TemporaryDirectoryCloseUndoMovedFiles temp_dir_close_undo_i386(i386_dir_path);
	TemporaryDirectory old_sp_files_dir_i386(this->temp_dir_path_, &temp_dir_close_undo_i386);
	fs::wpath const old_sp_files_dir_i386_path = old_sp_files_dir_i386.getDirectoryPath();
	// svcpack.inf̍폜
	fs::wpath svcpack_inf_path = i386_dir_path/L"svcpack.inf";
	MyLib::FileCompressionInfo compression_info(svcpack_inf_path.string().c_str());
	if (compression_info.exists()) {
		std::wstring const actual_path = compression_info.getActualPath().string();
		moveFileOrDirUsingWildCards(actual_path, old_sp_files_dir_i386_path);
	}
	// svcpacktH_̍폜
	moveFileOrDirUsingWildCards(i386_dir_path/L"svcpack", old_sp_files_dir_i386_path);
	// SP̃t@C폜
	moveFileOrDirUsingWildCards(this->target_dir_path_/L"CDROM*.TST", old_sp_files_dir_root_path);
	moveFileOrDirUsingWildCards(this->target_dir_path_/L"WIN51*.SP?", old_sp_files_dir_root_path);
	moveFileOrDirUsingWildCards(i386_dir_path/L"SP?.CAB", old_sp_files_dir_i386_path);
	moveFileOrDirUsingWildCards(i386_dir_path/L"SP?.CAT", old_sp_files_dir_i386_path);
	// SETUPORG.EXE ̍폜
	moveFileOrDirUsingWildCards(i386_dir_path/L"SETUPORG.EX?", old_sp_files_dir_i386_path);
	// SP̓Kp
	{
#if defined _M_X64
		static wchar_t const *UPDATE_EXE_REL_PATH = L"amd64\\update\\update.exe";
#elif defined _M_IA64
		static wchar_t const *UPDATE_EXE_REL_PATH = L"ia64\\update\\update.exe";
#else
		static wchar_t const *UPDATE_EXE_REL_PATH = L"i386\\update\\update.exe";
#endif
		fs::wpath const update_exe_path = temp_dir_path/UPDATE_EXE_REL_PATH;
		MyLib::OtherProcessExecutor update_exe;
		update_exe.run(update_exe_path.string() + _T(" -u -n -o -q -s:\"") + this->target_dir_path_.string() + _T("\""));
		update_exe.getStatus(INFINITE);
		unsigned int update_exe_exit_code = update_exe.getExitCode();
		if (update_exe_exit_code != 0) {
			char buf[64];
			::wsprintfA(buf, "update.exe returned %d.", update_exe_exit_code);
			throw std::runtime_error(buf);
		}
	}
	old_sp_files_dir_root.setCloseBehavior(&temp_dir_close_delete);
	old_sp_files_dir_i386.setCloseBehavior(&temp_dir_close_delete);
	// svcpack.inf蒼
	{
		std::wstring const svcpack_inf_path_str = svcpack_inf_path.string();
		MyLib::AutoHandle<INVALID_HANDLE_VALUE> file_handle =
			::CreateFile(svcpack_inf_path_str.c_str(), GENERIC_WRITE,
			0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (file_handle.isInvalid()) {
			throw MY_WIN32_FILE_EXCEPTION_LAST_ERROR(svcpack_inf_path_str);
		}
		std::stringstream oss;
		oss << "[Version]\r\nSignature=\"$WINDOWS NT$\"\r\nMajorVersion=";
		oss << ((this->os_version_ >> 16) & 0xFFFF) << "\r\nMinorVersion=";
		oss << (this->os_version_ & 0xFFFF) << "\r\nBuildNumber=";
		switch (this->os_version_) {
		case 0x00050000:
			oss << 2195;	// 2000
			break;
		case 0x00050001:
			oss << 2600;	// XP
			break;
		case 0x00050002:
			oss << 3790;	// 2003
			break;
		default:
			oss << 0;
			// throw
		}
		oss << "\r\n[SetupData]\r\nCatalogSubDir=\"\\" << MyLib::convertToSJIS(this->setup_subdir_name_) << "\\svcpack\"\r\n";
		DWORD written_bytes;
		if (!::WriteFile(file_handle.get(), oss.str().c_str(), oss.str().length(), &written_bytes, NULL)) {
			throw MY_WIN32_FILE_EXCEPTION_LAST_ERROR(svcpack_inf_path_str);
		}
	}
	this->fireEvent(L"\n");
}
