﻿#include "SlipstreamSetting.h"

///////////////////////////////////////////////////////////////////////////////
//
//WorkDirSetting::WorkDirSetting()
//{
//}
//
//WorkDirSetting::WorkDirSetting(boost::filesystem::wpath const &work_dir_path)
//: work_dir_path(work_dir_path)
//{
//}
//
//boost::filesystem::wpath getWorkDirPath() const
//{
//	return this->work_dir_path;
//}
//
//bool WorkDirSetting::isEmpty() const
//{
//	return this->work_dir_path
//}
//
///////////////////////////////////////////////////////////////////////////////
//
//SPSetting::SPSetting(boost::filesystem::wpath sp_file_path,
//                     bool uses_bigdrive_w2k,
//                     bool clean_install_only,
//                     bool driver_cab_recompress)
//: sp_file_path(sp_file_path)
//, uses_bigdrive_w2k(uses_bigdrive_w2k)
//, clean_install_only(clean_install_only)
//, driver_cab_recompress(driver_cab_recompress)
//{
//}
//
//boost::filesystem::wpath SPSetting::getSPFileName() const
//{
//	return this->sp_file_path;
//}
//
//bool SPSetting::usesBigdriveW2K() const
//{
//	return this->uses_bigdrive_w2k;
//}
//
//bool SPSetting::isCleanInstallOnly() const
//{
//	return this->clean_install_only;
//}
//
//bool SPSetting::executesDriverCabRecompress() const
//{
//	return this->driver_cab_recompress;
//}
//
///////////////////////////////////////////////////////////////////////////////

SlipstreamSetting::SlipstreamSetting(boost::filesystem::wpath const &work_dir_path,
                                     bool creates_temp_work_dir,
                                     boost::filesystem::wpath const &sp_file_path,
                                     bool uses_bigdrive_w2k,
                                     bool clean_install_only,
                                     bool driver_cab_recompress,
                                     std::vector<DriverSetupData> const &add_drivers,
                                     DriverFileDataMap const &leave_drivers,
                                     DriverFileDataMap const &del_drivers,
                                     DriverServiceData const &leave_services,
                                     DriverServiceData const &del_services)
: work_dir_path(work_dir_path)
, creates_temp_work_dir(creates_temp_work_dir)
, sp_file_path(sp_file_path)
, uses_bigdrive_w2k(uses_bigdrive_w2k)
, clean_install_only(clean_install_only)
, driver_cab_recompress(driver_cab_recompress)
, add_drivers(add_drivers)
, leave_drivers(leave_drivers)
, del_drivers(del_drivers)
, leave_services(leave_services)
, del_services(del_services)
{
}

boost::filesystem::wpath SlipstreamSetting::getWorkDirPath() const
{
	return this->work_dir_path;
}

bool SlipstreamSetting::createsTempWorkDir() const
{
	return this->creates_temp_work_dir;
}

boost::filesystem::wpath SlipstreamSetting::getSPFileName() const
{
	return this->sp_file_path;
}

bool SlipstreamSetting::usesBigdriveW2K() const
{
	return this->uses_bigdrive_w2k;
}

bool SlipstreamSetting::isCleanInstallOnly() const
{
	return this->clean_install_only;
}

bool SlipstreamSetting::executesDriverCabRecompress() const
{
	return this->driver_cab_recompress;
}

std::vector<DriverSetupData> SlipstreamSetting::getAddDriverCollection() const
{
	return this->add_drivers;
}

DriverFileDataMap SlipstreamSetting::getLeaveDrivers() const
{
	return this->leave_drivers;
}

DriverFileDataMap SlipstreamSetting::getDelDrivers() const
{
	return this->del_drivers;
}

DriverServiceData SlipstreamSetting::getLeaveServices() const
{
	return this->leave_services;
}

DriverServiceData SlipstreamSetting::getDelServices() const
{
	return this->del_services;
}

