﻿#pragma once

#include "DriverSetupData.h"
#include "DriverFileData.h"
#include "DriverServiceData.h"

///////////////////////////////////////////////////////////////////////////////
//
//class WorkDirSetting
//{
//	boost::filesystem::wpath work_dir_path;
//public:
//	WorkDirSetting();
//	WorkDirSetting(boost::filesystem::wpath const &work_dir_path);
//	boost::filesystem::wpath getWorkDirPath() const;
//	bool isEmpty() const;
//};
//
///////////////////////////////////////////////////////////////////////////////
//
//class SPSetting
//{
//	boost::filesystem::wpath sp_file_path;
//	bool uses_bigdrive_w2k;
//	bool clean_install_only;
//	bool driver_cab_recompress;
//public:
//	SPSetting(boost::filesystem::wpath sp_file_path,
//	          bool uses_bigdrive_w2k,
//	          bool clean_install_only,
//	          bool driver_cab_recompress);
//	boost::filesystem::wpath getSPFileName() const;
//	bool usesBigdriveW2K() const;
//	bool isCleanInstallOnly() const;
//	bool executesDriverCabRecompress() const;
//};
//
///////////////////////////////////////////////////////////////////////////////

class SlipstreamSetting
{
public:
	SlipstreamSetting(boost::filesystem::wpath const &work_dir_path,
	                  bool creates_temp_work_dir,
	                  boost::filesystem::wpath const &sp_file_path,
	                  bool uses_bigdrive_w2k,
	                  bool clean_install_only,
	                  bool driver_cab_recompress,
	                  std::vector<DriverSetupData> const &add_drivers,
	                  DriverFileDataMap const &leave_drivers,
	                  DriverFileDataMap const &del_drivers,
	                  DriverServiceData const &leave_services,
	                  DriverServiceData const &del_services);

	boost::filesystem::wpath getWorkDirPath() const;
	bool createsTempWorkDir() const;
	boost::filesystem::wpath getSPFileName() const;
	bool usesBigdriveW2K() const;
	bool isCleanInstallOnly() const;
	bool executesDriverCabRecompress() const;
	std::vector<DriverSetupData> getAddDriverCollection() const;
	DriverFileDataMap getLeaveDrivers() const;
	DriverFileDataMap getDelDrivers() const;
	DriverServiceData getLeaveServices() const;
	DriverServiceData getDelServices() const;

protected:
	boost::filesystem::wpath work_dir_path;
	bool creates_temp_work_dir;
	boost::filesystem::wpath sp_file_path;
	bool uses_bigdrive_w2k;
	bool clean_install_only;
	bool driver_cab_recompress;
	std::vector<DriverSetupData> add_drivers;
	DriverFileDataMap leave_drivers;
	DriverFileDataMap del_drivers;
	DriverServiceData leave_services;
	DriverServiceData del_services;
};

