#include "WorkingDirectoryPrepare.h"
#include "mylib/function.h"

extern void deleteDirectory(boost::filesystem::wpath const &dir_path);
extern void copyDirectory(boost::filesystem::wpath const &source_dir,
                          boost::filesystem::wpath const &destination_dir);

/////////////////////////////////////////////////////////////////////////////

WorkingDirectoryPrepare::WorkingDirectoryPrepare(boost::filesystem::wpath const &source_path,
                                                 boost::filesystem::wpath const &temp_work_dir_path)
	: source_path_(source_path)
	, temp_work_dir_path_(temp_work_dir_path)
{
}

void WorkingDirectoryPrepare::execute()
{
	namespace fs = boost::filesystem;
	fs::wdirectory_iterator it_end;
	for (fs::wdirectory_iterator it(this->source_path_); it != it_end; ++it) {
		fs::wpath p = it->path();
		if (MyLib::compareStringNoCase(p.string(), this->temp_work_dir_path_.string()) != 0) {
			fs::wpath dst_path = this->temp_work_dir_path_/p.filename();
			fs::rename(p, dst_path);
			//if (!::MoveFile(p.string().c_str(), dst_path.string().c_str())) {
			//	//assert(L"%s\n", src_path.str().c_str());
			//	throw MY_WIN32_EXCEPTION_LAST_ERROR;
			//}
		}
	}

	//CFindFile finder;
	//const PathString wild_card = work_dir_path + _T("*.*");
	//if (finder.FindFile(wild_card.str().c_str())) {
	//	do {
	//		if (!finder.IsDots()) {
	//			TCHAR buf[MAX_PATH];
	//			finder.GetFileName(buf, MAX_PATH);
	//			const PathString src_path = work_dir_path + buf;
	//			// ꎞfBNĝړȂ悤ɂ
	//			if (MyLib::compareStringNoCase(src_path.str(), temp_work_dir_path.str()) != 0) {
	//				const PathString dest_path = temp_work_dir_path + buf;
	//				if (!::MoveFile(src_path.str().c_str(), dest_path.str().c_str())) {
	//					ATLTRACE(_T("%s\n"), src_path.str().c_str());
	//					throw MY_WIN32_EXCEPTION_LAST_ERROR;
	//				}
	//			}
	//		}
	//	} while (finder.FindNextFile());
	//}
}

/////////////////////////////////////////////////////////////////////////////

WorkingDirectoryPrepareWithFileCopy::WorkingDirectoryPrepareWithFileCopy(boost::filesystem::wpath const &source_path,
                                                                         boost::filesystem::wpath const &temp_work_dir_path)
	: WorkingDirectoryPrepare(source_path, temp_work_dir_path)
{
}

void WorkingDirectoryPrepareWithFileCopy::execute()
{
	this->fireEvent(L"CXg[t@CƃtH_ɃRs[Ă܂BBB");
	copyDirectory(this->source_path_, this->temp_work_dir_path_);
	this->fireEvent(L"\n");
}
