#include <tchar.h>
#include <windows.h>

#pragma comment(lib, "kernel32.lib")
#pragma comment(lib, "user32.lib")
#pragma comment(lib, "advapi32.lib")
#ifdef NDEBUG
#pragma comment(linker, "/ENTRY:\"wWinMain\"")
#endif

/*
 * ResetDevicePath.exe
 *	SetDevicePath.exe ɂĕύXꂽWXglɖ߂B
 */


int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HKEY reg_key;
	DWORD reg_type, reg_data_size;
	LPTSTR f6tool_device_path, src_ptr, dst_ptr, ptr, src_ptr_start, dst_ptr_end;
	int f6tool_device_path_len;
	wchar_t const *F6TOOL_DEVICE_PATH_ENTRY_NAME = L"F6ToolDevicePath";
	wchar_t const *DEVICE_PATH_ENTRY_NAME = L"DevicePath";
	LSTATUS ret;

	UNREFERENCED_PARAMETER(hInstance);
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpstrCmdLine);
	UNREFERENCED_PARAMETER(nCmdShow);

	ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
	                   L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion",
	                   0,
	                   KEY_ALL_ACCESS,
	                   &reg_key);
	if (ret != 0) {
		return EXIT_FAILURE;
	}
	/* hCopfBNghCuɊ蓖Ă */
	ret = RegQueryValueEx(reg_key,
	                      F6TOOL_DEVICE_PATH_ENTRY_NAME,
	                      0,
	                      &reg_type,
	                      NULL,
	                      &reg_data_size);
	if (ret != 0) {
		RegCloseKey(reg_key);
		return EXIT_FAILURE;
	}
	f6tool_device_path = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, reg_data_size);
	RegQueryValueEx(reg_key, F6TOOL_DEVICE_PATH_ENTRY_NAME, 0, &reg_type, (BYTE*)f6tool_device_path, &reg_data_size);
	f6tool_device_path_len = lstrlen(f6tool_device_path);
	if (f6tool_device_path_len < 2) {
		RegCloseKey(reg_key);
		HeapFree(GetProcessHeap(), 0, f6tool_device_path);
		return EXIT_FAILURE;
	}
	/* F6ToolDevicePath Gg폜 */
	RegDeleteValue(reg_key, F6TOOL_DEVICE_PATH_ENTRY_NAME);

	/* DevicePathGghCopfBNg̃hCu폜 */
	RegQueryValueEx(reg_key, DEVICE_PATH_ENTRY_NAME, 0, &reg_type, NULL, &reg_data_size);
	src_ptr = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, reg_data_size);
	dst_ptr = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, reg_data_size);
	RegQueryValueEx(reg_key, DEVICE_PATH_ENTRY_NAME, 0, &reg_type, (BYTE*)src_ptr, &reg_data_size);
	src_ptr_start = src_ptr;
	dst_ptr_end = dst_ptr;
	for (ptr = src_ptr; ; ptr = CharNext(ptr)) {
		if (*ptr == L';' || *ptr == L'\0') {
			int device_path_part_len = ptr - src_ptr_start;
#if defined(_M_X64) || defined(_M_IA64)
			if (device_path_part_len < f6tool_device_path_len || RtlCompareMemory(src_ptr_start, f6tool_device_path, f6tool_device_path_len*sizeof(wchar_t)) != 0) {
#else
			if (device_path_part_len < f6tool_device_path_len || memcmp(src_ptr_start, f6tool_device_path, f6tool_device_path_len*sizeof(wchar_t)) != 0) {
#endif
				if (dst_ptr_end != dst_ptr) {
					lstrcpy(dst_ptr_end, L";");
					++dst_ptr_end;
				}
				lstrcpyn(dst_ptr_end, src_ptr_start, device_path_part_len + 1);
				dst_ptr_end += device_path_part_len;
			}
			if (*ptr == L'\0') {
				break;
			} else {
				src_ptr_start = CharNext(ptr);
			}
		}
	}
	RegSetValueEx(reg_key, DEVICE_PATH_ENTRY_NAME, 0, reg_type,
		(BYTE * const)dst_ptr, (DWORD)((_tcslen(dst_ptr) + 1)*sizeof(TCHAR)));
	HeapFree(GetProcessHeap(), 0, src_ptr);
	HeapFree(GetProcessHeap(), 0, dst_ptr);

	RegCloseKey(reg_key);

#if defined(_M_X64) || defined(_M_IA64)
	RegOpenKeyEx(HKEY_LOCAL_MACHINE,
		_T("SOFTWARE\\Wow6432Node\\Microsoft\\Windows\\CurrentVersion"), 0, KEY_ALL_ACCESS, &reg_key);
	RegQueryValueEx(reg_key, DEVICE_PATH_ENTRY_NAME, 0, &reg_type, NULL, &reg_data_size);
	src_ptr = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, reg_data_size);
	dst_ptr = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, reg_data_size);
	RegQueryValueEx(reg_key, DEVICE_PATH_ENTRY_NAME, 0, &reg_type, (BYTE*)src_ptr, &reg_data_size);
	src_ptr_start = src_ptr;
	dst_ptr_end = dst_ptr;
	for (ptr = src_ptr; ; ptr = CharNext(ptr)) {
		if (*ptr == L';' || *ptr == L'\0') {
			int device_path_part_len = ptr - src_ptr_start;
			if (device_path_part_len < f6tool_device_path_len || RtlCompareMemory(src_ptr_start, f6tool_device_path, f6tool_device_path_len*sizeof(wchar_t)) != 0) {
				if (dst_ptr_end != dst_ptr) {
					lstrcpy(dst_ptr_end, L";");
					++dst_ptr_end;
				}
				lstrcpyn(dst_ptr_end, src_ptr_start, device_path_part_len + 1);
				dst_ptr_end += device_path_part_len;
			}
			if (*ptr == L'\0') {
				break;
			} else {
				src_ptr_start = CharNext(ptr);
			}
		}
	}
	RegSetValueEx(reg_key, DEVICE_PATH_ENTRY_NAME, 0, reg_type,
		(BYTE * const)dst_ptr, (DWORD)((_tcslen(dst_ptr) + 1)*sizeof(TCHAR)));
	HeapFree(GetProcessHeap(), 0, src_ptr);
	HeapFree(GetProcessHeap(), 0, dst_ptr);
	RegCloseKey(reg_key);
#endif
	HeapFree(GetProcessHeap(), 0, f6tool_device_path);

	return 0;
}
