#pragma once

class FileToWritable
{
public:
	FileToWritable(std::wstring const &file_path)
	: file_path(file_path)
	, original_attributes(::GetFileAttributes(file_path.c_str()))
	{
		if (this->original_attributes != 0xFFFFFFFF) {
			DWORD attribs = this->original_attributes;
			//attribs |= ~(FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM);
			attribs = FILE_ATTRIBUTE_NORMAL;
			::SetFileAttributes(this->file_path.c_str(), attribs);
		}
	}

	~FileToWritable()
	{
		if (this->original_attributes != 0xFFFFFFFF) {
			::SetFileAttributes(this->file_path.c_str(),
			                    this->original_attributes);
		}
	}

private:
	std::wstring file_path;
	DWORD original_attributes;
};
