#ifndef CAB_COMPRESSOR_H__73F4CB54_B21D_42CB_A11A_1DC23235990C__INCLUDED
#define CAB_COMPRESSOR_H__73F4CB54_B21D_42CB_A11A_1DC23235990C__INCLUDED
// M$ compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/////////////////////////////////////////////////////////////////////////////
// CabCompressor.h
//  Cabinet.dllFCI(File Compression Interface)gpāA
//  t@CCabinetk
// QlF
//  [http://support.microsoft.com/kb/310618/ja]
//  [http://www.codeproject.com/KB/files/CABCompressExtract.aspx]
//  [http://d.hatena.ne.jp/hasegawayosuke/20060130/1138597266]
//  [http://d.hatena.ne.jp/hasegawayosuke/20060208/1139381353]
// XVF
//  H20(2008)/01/14 쐬
//	H20(2008)/01/26 RpČxx4ŁAwarning C4100
//					(͊֐̖{̕ 1 xQƂ܂B)
//					ʂɏoĂ̂C
//	H20(2008)/06/07 onGetOpenInfo()Ńt@CĂȂ̂C
//	H21(2009)/06/06 boost::filesystem, boost::scoped_array ̓
// Classes in this file:
//  FCIError
//  CabCompressorT
//  CabCompressor
/////////////////////////////////////////////////////////////////////////////

//#define NOMINMAX
//#include <windows.h>
//#include <io.h>     // _tsopen_s()
//#include <fcntl.h>  // _O_RDONLY | _O_BINARY
//#include <FCI.h>
//#pragma comment(lib, "FCI.lib")
//#include <cstdlib>  // _get_errno()
//#include <cerrno>   // errno_t
//#include <cstring>
//#include <vector>
//#include <shlwapi.h>  // PathFindFileName()
//#pragma comment(lib, "shlwapi.lib")
//#include "MyLib.h"    // Win32Error, std::wstring

namespace MyLib {
/////////////////////////////////////////////////////////////////////////
// FCIError
//	FCIG[\ERF̗ONX
/////////////////////////////////////////////////////////////////////////
class FCIError
	: public std::runtime_error
{
	ERF err_code;

public:
	FCIError(ERF& code);
	static const std::string makeErrorMessage(ERF& code);
};

inline FCIError::FCIError(ERF& code)
: std::runtime_error(makeErrorMessage(code))
, err_code(code)
{
}

// FCĨG[Ԃ
inline const std::string FCIError::makeErrorMessage(ERF& code)
{
	std::string result;
	switch (code.erfOper) {
	case FCIERR_NONE:
		result = "No error";
		break;
	case FCIERR_OPEN_SRC:
		result = "Failure opening file to be stored in cabinet\n";
		//  erf.erfTyp has C run-time *errno* value
//        if (code.erfType > 0) {
			//result += MyLib::StdCError::makeErrorMessage(code.erfType);
//        } else {
//            result += MyLib::Win32Error::makeErrorMessage(code.erfType);
//        }
		break;
	case FCIERR_READ_SRC:
		result = "Failure reading file to be stored in cabinet\n";
		//  erf.erfTyp has C run-time *errno* value
//        if (code.erfType > 0) {
			//result += MyLib::StdCError::makeErrorMessage(code.erfType);
//        } else {
//            result += MyLib::Win32Error::makeErrorMessage(code.erfType);
//        }
		break;
	case FCIERR_ALLOC_FAIL:
		result = "Out of memory in CabCompressorT";
		break;
	case FCIERR_TEMP_FILE:
		result = "Could not create a temporary file\n";
		//  erf.erfTyp has C run-time *errno* value
//        if (code.erfType > 0) {
			//result += MyLib::StdCError::makeErrorMessage(code.erfType);
//        } else {
//            result += MyLib::Win32Error::makeErrorMessage(code.erfType);
//        }
		break;
	case FCIERR_BAD_COMPR_TYPE:
		result = "Unknown compression type";
		break;
	case FCIERR_CAB_FILE:
		result = "Could not create cabinet file\n";
		//  erf.erfTyp has C run-time *errno* value
//        if (code.erfType > 0) {
			//result += MyLib::StdCError::makeErrorMessage(code.erfType);
//        } else {
//            result += MyLib::Win32Error::makeErrorMessage(code.erfType);
//        }
		break;
	case FCIERR_USER_ABORT:
		result = "Client requested abort";
		break;
	case FCIERR_MCI_FAIL:
		result = "Failure compressing data";
		break;
	}
	return result;
}

/////////////////////////////////////////////////////////////////////////////
// CabCompressorT
//  CabinetkNX̊NX
/////////////////////////////////////////////////////////////////////////////
template <class T>
class CabCompressorT
{
public:
	// t@C̕GR[h`
	enum FileNameEncoding {
		SJIS,
		UTF8,
		ENCODING_COUNT
	};

protected:
	// GR[h`ǗNX
	class Encoding
	{
	public:
		Encoding(enum FileNameEncoding enc)
			: file_name_encoding(enc)
		{
			this->convertToCabEncodingString[SJIS] = &convertToSJIS;
			this->convertToCabEncodingString[UTF8] = &convertToUTF8;
			this->convertToCabEncodingBuffer[SJIS] = &convertToSJIS;
			this->convertToCabEncodingBuffer[UTF8] = &convertToUTF8;
			this->convertFromCabEncodingString[SJIS] = &convertFromSJIS;
			this->convertFromCabEncodingString[UTF8] = &convertFromUTF8;
		}
		bool operator==(enum FileNameEncoding enc) const
		{
			return this->file_name_encoding == enc;
		}
		std::string convertToCabEncoding(std::wstring const &str) const
		{
			return (*this->convertToCabEncodingString[this->file_name_encoding])(str);
		}
		int convertToCabEncoding(wchar_t const *src, char *dest, size_t dest_size) const
		{
			return (*this->convertToCabEncodingBuffer[this->file_name_encoding])(src, dest, dest_size);
		}
		std::wstring convertFromCabEncoding(std::string const &str) const
		{
			return (*this->convertFromCabEncodingString[this->file_name_encoding])(str);
		}
	private:
		enum FileNameEncoding file_name_encoding;
		std::string (*convertToCabEncodingString[ENCODING_COUNT])(std::wstring const &);
		int (*convertToCabEncodingBuffer[ENCODING_COUNT])(wchar_t const *, char *, size_t);
		std::wstring (*convertFromCabEncodingString[ENCODING_COUNT])(std::string const &);
	};

private:
	bool needs_to_flush;
	Encoding filename_encoding;
	CCAB cab_params;
	HFCI fci_handle;
	ERF err_code;

public:
	//
	// RXgN^
	// F
	//  cab_params  : CCAB\
	//  encoding    : Cabinet̃t@C̕GR[h`
	//
	CabCompressorT(
		const CCAB& cab_params,
		enum FileNameEncoding encoding = SHIFT_JIS);     // t@C̃GR[h`

	//
	// fXgN^
	//
	virtual ~CabCompressorT();

	//
	// addFile
	//  CabinetɃt@Cǉ
	// F
	//  file_to_add : ǉt@C
	//  name_in_cab : Cabinetł̃t@C
	//  executable  : s\
	//  compression_type    : k`
	//
	void addFile(
		boost::filesystem::wpath const &file_to_add,
		bool executable = false,
		TCOMP compression_type = tcompTYPE_MSZIP);
	void addFile(
		boost::filesystem::wpath const &file_to_add,
		std::wstring const &name_in_cab,
		bool executable = false,
		TCOMP compression_type = tcompTYPE_MSZIP);

	//
	// flush
	//  Cabinetflush
	// F
	//  creates_new_cabinet :
	//
	void flush(bool creates_new_cabinet);

	//
	// flush
	//  Floderflush
	//
	void flushFolder(void);

protected:
	// overrides
	FNFCIOPEN(onOpen);
	FNFCIREAD(onRead);
	FNFCIWRITE(onWrite);
	FNFCICLOSE(onClose);
	FNFCISEEK(onSeek);
	FNFCIDELETE(onDelete);
	FNFCIFILEPLACED(onFilePlaced);
	FNFCIGETTEMPFILE(onGetTempFile);
	FNFCISTATUS(onStatus);
	FNFCIGETNEXTCABINET(onGetNextCabinet);
	FNFCIGETOPENINFO(onGetOpenInfo);

private:
	static FNFCIALLOC(fciAlloc);
	static FNFCIFREE(fciFree);
	static FNFCIOPEN(fciOpen);
	static FNFCIREAD(fciRead);
	static FNFCIWRITE(fciWrite);
	static FNFCICLOSE(fciClose);
	static FNFCISEEK(fciSeek);
	static FNFCIDELETE(fciDelete);
	static FNFCIFILEPLACED(fciFilePlaced);
	static FNFCIGETTEMPFILE(fciGetTempFile);
	static FNFCISTATUS(fciStatus);
	static FNFCIGETNEXTCABINET(fciGetNextCabinet);
	static FNFCIGETOPENINFO(fciGetOpenInfo);
};

template <class T>
inline CabCompressorT<T>::CabCompressorT(
	const CCAB& params,
	enum FileNameEncoding encoding)
: needs_to_flush(true)
, filename_encoding(encoding)
, cab_params(params)
{
	// fci_handlȅ
	this->fci_handle = ::FCICreate(&this->err_code, fciFilePlaced, fciAlloc,
		fciFree, fciOpen, fciRead, fciWrite, fciClose, fciSeek, fciDelete,
		fciGetTempFile, &this->cab_params, this);
	if (this->fci_handle == NULL) {
		throw FCIError(this->err_code);
	}
}

template <class T>
inline CabCompressorT<T>::~CabCompressorT(void)
{
	if (this->needs_to_flush) {
		try {
			// The user has not yet flushed the cabinet
			this->flush(false);
		} catch (FCIError&) {
			// nop
		}
	}

	if (this->fci_handle != NULL) {
		// The only reason for failure is that the hfdi passed in
		// was not a proper context handle.
		::FCIDestroy(this->fci_handle);
		this->fci_handle = NULL;
	}
}

template <class T>
inline void CabCompressorT<T>::addFile(boost::filesystem::wpath const &file_to_add,
                                       bool executable,
                                       TCOMP compression_type)
{
	this->addFile(file_to_add, file_to_add.filename(), executable, compression_type);
}
template <class T>
inline void CabCompressorT<T>::addFile(boost::filesystem::wpath const &file_to_add,
                                       std::wstring const &name_in_cab,
                                       bool executable,
                                       TCOMP compression_type)
{
	std::string file_to_add_str =
		this->filename_encoding.convertToCabEncoding(file_to_add.string());
	size_t const file_to_add_size = file_to_add_str.length() + 1;
	boost::scoped_array<char> file_to_add_buf(new char[file_to_add_size]);
	std::memcpy(file_to_add_buf.get(), file_to_add_str.c_str(), file_to_add_size);

	std::string name_in_cab_str =
		this->filename_encoding.convertToCabEncoding(name_in_cab);
	size_t const name_in_cab_size = name_in_cab_str.length() + 1;
	boost::scoped_array<char> name_in_cab_buf(new char[name_in_cab_size]);
	std::memcpy(name_in_cab_buf.get(), name_in_cab_str.c_str(), name_in_cab_size);

	const bool ret = (::FCIAddFile(this->fci_handle, file_to_add_buf.get(),
		name_in_cab_buf.get(), executable ? TRUE : FALSE, fciGetNextCabinet,
		fciStatus, fciGetOpenInfo, compression_type) != 0);
	if (!ret) {
		throw FCIError(this->err_code);
	} else {
		this->needs_to_flush = true;
	}
}

template <class T>
inline void CabCompressorT<T>::flush(bool creates_new_cabinet)
{
	const bool ret = (::FCIFlushCabinet(this->fci_handle,
		creates_new_cabinet ? TRUE : FALSE, fciGetNextCabinet, fciStatus) != 0);
	if (!ret) {
		throw FCIError(this->err_code);
	} else {
		this->needs_to_flush = false;
	}
}

template <class T>
inline void CabCompressorT<T>::flushFolder(void)
{
	const bool ret =
		(::FCIFlushFolder(this->fci_handle, fciGetNextCabinet, fciStatus) != 0);
	if (!ret) {
		throw FCIError(this->err_code);
	} else {
		this->needs_to_flush = true;
	}
}

/////////////////////////////////////////////////////////////////////////////

template <class T>
//inline FNFCIOPEN(CabCompressorT<T>::onOpen)
inline intptr_t FAR DIAMONDAPI CabCompressorT<T>::onOpen(
	char FAR * pszFile, int oflag, int pmode, int FAR * err, void FAR * /*pv*/)
{
	int result = 0;
	try {
		std::wstring file_name =
			this->filename_encoding.convertFromCabEncoding(pszFile);
#if defined(_MSC_VER) && (_MSC_VER >= 1400) /* VC 2005 */
		int error =
			::_tsopen_s(&result, file_name.c_str(), oflag, _SH_DENYNO, pmode);
		if (result == -1) {
			*err = error;
		}
#else /* others */
#error Not implemented
#endif
	} catch (StdCException& e) {
		*err = e.getErrorCode();
		result = -1;
	}
	return result;
}

template <class T>
//inline FNFCIREAD(CabCompressorT<T>::onRead)
inline unsigned FAR DIAMONDAPI CabCompressorT<T>::onRead(
	intptr_t hf, void FAR * memory, unsigned cb, int FAR * err, void FAR * /*pv*/)
{
	unsigned result = static_cast<unsigned>(::_read(static_cast<int>(hf), memory, cb));
	if (result != cb) {
		::_get_errno(err);
	}
	return result;
}

template <class T>
//inline FNFCIWRITE(CabCompressorT<T>::onWrite)
inline unsigned FAR DIAMONDAPI CabCompressorT<T>::onWrite(
	intptr_t hf, void FAR * memory, unsigned cb, int FAR * err, void FAR * /*pv*/)
{
	unsigned result = static_cast<unsigned>(::_write(static_cast<int>(hf), memory, cb));
	if (result != cb) {
		::_get_errno(err);
	}
	return result;
}

template <class T>
//inline FNFCICLOSE(CabCompressorT<T>::onClose)
inline int FAR DIAMONDAPI CabCompressorT<T>::onClose(
	intptr_t hf, int FAR * err, void FAR * /*pv*/)
{
	int result = 0;
	if (hf != -1) {
		::_close(static_cast<int>(hf));
		if (result != 0) {
			::_get_errno(err);
		}
	}
	return result;
}

template <class T>
//inline FNFCISEEK(CabCompressorT<T>::onSeek)
inline long FAR DIAMONDAPI CabCompressorT<T>::onSeek(
	intptr_t hf, long dist, int seektype, int FAR * err, void FAR * /*pv*/)
{
	long result = ::_lseek(static_cast<int>(hf), dist, seektype);
	if (result == -1) {
		::_get_errno(err);
	}
	return result;
}

template <class T>
//inline FNFCIDELETE(CabCompressorT<T>::onDelete)
inline int FAR DIAMONDAPI CabCompressorT<T>::onDelete(
	char FAR * pszFile, int FAR * err, void FAR * /*pv*/)
{
	int result = 0;
	try {
		// R[hϊ
		std::wstring file_name =
			this->filename_encoding.convertFromCabEncoding(pszFile);
		result = ::_tremove(file_name.c_str());
		if (result != 0) {
			::_get_errno(err);
		}
	} catch (StdCException& e) {
		result = e.getErrorCode();
	}
	return result;
}

template <class T>
//inline FNFCIFILEPLACED(CabCompressorT<T>::onFilePlaced)
inline int DIAMONDAPI CabCompressorT<T>::onFilePlaced(
	PCCAB /*pccab*/, char * /*pszFile*/, long /*cbFile*/, BOOL /*fContinuation*/, void FAR * /*pv*/)
{
	//while (true)
	//{
	//	sprintf(pszTempName, "%sCabTemp%04u", ms8_TempDir, ms32_TempCounter++);

	//	// Check if the file already exists
	//	int Ret = GetFileAttributesA(pszTempName);
	//	if (Ret == -1) // error reading file attributes
	//		return TRUE;
	//}

 //   printf(
	//	"   placed file '%s' (size %d) on cabinet '%s'\n",
	//	pszFile, 
	//	cbFile, 
	//	pccab->szCab
	//);
	//if (fContinuation)
	//	printf("      (Above file is a later segment of a continued file)\n");

	return 0;
}

template <class T>
//inline FNFCIGETTEMPFILE(CabCompressorT<T>::onGetTempFile)
inline BOOL DIAMONDAPI CabCompressorT<T>::onGetTempFile(
	char *pszTempName, int cbTempName, void FAR * /*pv*/)
{
	BOOL result = FALSE;
	try {
		std::wstring temp_file_name = createTemporaryFilePath().string();
		if (temp_file_name.length() < static_cast<unsigned>(cbTempName)) {
			// Cabinet̃t@CGR[h`ɕϊ
			int ret = this->filename_encoding.convertToCabEncoding(
				temp_file_name.c_str(), pszTempName, cbTempName);
			result = (ret == 0);
		}
	} catch (const std::runtime_error&) {
		// nop
	}
	return result;
}

template <class T>
//inline FNFCISTATUS(CabCompressorT<T>::onStatus)
inline long DIAMONDAPI CabCompressorT<T>::onStatus(
	unsigned /*typeStatus*/, ULONG /*cb1*/, ULONG /*cb2*/, void FAR * /*pv*/)
{
	//client_state	*cs;

	//cs = (client_state *) pv;

	//if (typeStatus == statusFile)
	//{
 //       cs->total_compressed_size += cb1;
	//	cs->total_uncompressed_size += cb2;

	//	/*
	//	 * Compressing a block into a folder
	//	 *
	//	 * cb2 = uncompressed size of block
	//	 */
	//	printf(
 //           "Compressing: %9ld -> %9ld             \r",
 //           cs->total_uncompressed_size,
 //           cs->total_compressed_size
	//	);
	//	
	//	fflush(stdout);
	//}
	//else if (typeStatus == statusFolder)
	//{
	//	int	percentage;

	//	/*
	//	 * Adding a folder to a cabinet
	//	 *
	//	 * cb1 = amount of folder copied to cabinet so far
	//	 * cb2 = total size of folder
	//	 */
	//	percentage = get_percentage(cb1, cb2);

	//	printf("Copying folder to cabinet: %d%%      \r", percentage);
	//	fflush(stdout);
	//}

	return 0;
}

template <class T>
//inline FNFCIGETNEXTCABINET(CabCompressorT<T>::onGetNextCabinet)
inline BOOL DIAMONDAPI CabCompressorT<T>::onGetNextCabinet(
	PCCAB /*pccab*/, ULONG /*cbPrevCab*/, void FAR * /*pv*/)
{
	/*
	 * Cabinet counter has been incremented already by CabCompressorT
	 */

	/*
	 * Store next cabinet name
	 */
	//store_cab_name(pccab->szCab, pccab->iCab);

	/*
	 * You could change the disk name here too, if you wanted
	 */

	return TRUE;
}

template <class T>
//	inline FNFCIGETOPENINFO(CabCompressorT<T>::onGetOpenInfo)
inline intptr_t DIAMONDAPI CabCompressorT<T>::onGetOpenInfo(
	char *pszName, USHORT *pdate, USHORT *ptime, USHORT *pattribs, int FAR *err, void FAR * /*pv*/)
{
	int result = -1;

	std::wstring file_name;
	try {
		file_name =
			this->filename_encoding.convertFromCabEncoding(pszName);
	} catch (StdCException& e) {
		return e.getErrorCode();
	}

	//// Do not use _open() here! (We need a Win32 type handle here)
	AutoHandle<INVALID_HANDLE_VALUE> hfile = ::CreateFile(file_name.c_str(),
		GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if (!hfile.isInvalid()) {
		BY_HANDLE_FILE_INFORMATION	file_info;
		FILETIME file_time;
		if (::GetFileInformationByHandle(hfile.get(), &file_info)) {
			// t@C
			::FileTimeToLocalFileTime(&file_info.ftLastWriteTime, &file_time);
			::FileTimeToDosDateTime(&file_time, pdate, ptime);
			// t@C̑
			uint32_t attribs = ::GetFileAttributes(file_name.c_str());
			if (attribs == 0xFFFFFFFF) {
				*pattribs = 0; // Failure -> don't abort for missing attributes
			} else {
				// Mask out all other bits except these four, since other bits are used 
				// by the cabinet format to indicate a special meaning.
				*pattribs = static_cast<uint16_t>(
					attribs & (_A_RDONLY | _A_SYSTEM | _A_HIDDEN | _A_ARCH));
			}
			// UTF-8
			if (this->filename_encoding == UTF8) {
				*pattribs |= _A_NAME_IS_UTF;
			}
			// Return handle using _open
#if defined(_MSC_VER) && (_MSC_VER >= 1400) /* VC 2005 */
			*err = ::_tsopen_s(&result, file_name.c_str(),
				_O_RDONLY | _O_BINARY, _SH_DENYNO, 0);
#else /* others */
#error Not implemented
#endif
		} else {
			*err = ::GetLastError();
			//::CloseHandle(hfile);
		}
	} else {
		*err = ::GetLastError();
	}
	return result;
}

/////////////////////////////////////////////////////////////////////////////

template <class T>
inline FNFCIALLOC(CabCompressorT<T>::fciAlloc)
{
	return operator new(cb); 
}

template <class T>
inline FNFCIFREE(CabCompressorT<T>::fciFree)
{
	operator delete(memory); 
}

template <class T>
inline FNFCIOPEN(CabCompressorT<T>::fciOpen)
{
	CabCompressorT* ptr = reinterpret_cast<CabCompressorT*>(pv);
	return ptr->onOpen(pszFile, oflag, pmode, err, pv);
}

template <class T>
inline FNFCIREAD(CabCompressorT<T>::fciRead)
{
	CabCompressorT* ptr = reinterpret_cast<CabCompressorT*>(pv);
	return ptr->onRead(hf, memory, cb, err, pv);
}

template <class T>
inline FNFCIWRITE(CabCompressorT<T>::fciWrite)
{
	CabCompressorT* ptr = reinterpret_cast<CabCompressorT*>(pv);
	return ptr->onWrite(hf, memory, cb, err, pv);
}

template <class T>
inline FNFCICLOSE(CabCompressorT<T>::fciClose)
{
	CabCompressorT* ptr = reinterpret_cast<CabCompressorT*>(pv);
	return ptr->onClose(hf, err, pv);
}

template <class T>
inline FNFCISEEK(CabCompressorT<T>::fciSeek)
{
	CabCompressorT* ptr = reinterpret_cast<CabCompressorT*>(pv);
	return ptr->onSeek(hf, dist, seektype, err, pv);
}

template <class T>
inline FNFCIDELETE(CabCompressorT<T>::fciDelete)
{
	CabCompressorT* ptr = reinterpret_cast<CabCompressorT*>(pv);
	return ptr->onDelete(pszFile, err, pv);
}

template <class T>
inline FNFCIFILEPLACED(CabCompressorT<T>::fciFilePlaced)
{
	CabCompressorT* ptr = reinterpret_cast<CabCompressorT*>(pv);
	return ptr->onFilePlaced(pccab, pszFile, cbFile, fContinuation, pv);
}

template <class T>
inline FNFCIGETTEMPFILE(CabCompressorT<T>::fciGetTempFile)
{
	CabCompressorT* ptr = reinterpret_cast<CabCompressorT*>(pv);
	return ptr->onGetTempFile(pszTempName, cbTempName, pv);
}

template <class T>
inline FNFCISTATUS(CabCompressorT<T>::fciStatus)
{
	//CabCompressorT* ptr = reinterpret_cast<CabCompressorT*>(pv);
	T* ptr = reinterpret_cast<T*>(pv);
	return ptr->onStatus(typeStatus, cb1, cb2, pv);
}

template <class T>
inline FNFCIGETNEXTCABINET(CabCompressorT<T>::fciGetNextCabinet)
{
	CabCompressorT* ptr = reinterpret_cast<CabCompressorT*>(pv);
	return ptr->onGetNextCabinet(pccab, cbPrevCab, pv);
}

template <class T>
inline FNFCIGETOPENINFO(CabCompressorT<T>::fciGetOpenInfo)
{
	CabCompressorT* ptr = reinterpret_cast<CabCompressorT*>(pv);
	return ptr->onGetOpenInfo(pszName, pdate, ptime, pattribs, err, pv);
}

/////////////////////////////////////////////////////////////////////////
// CabCompressor
/////////////////////////////////////////////////////////////////////////
class CabCompressor
	: public CabCompressorT<CabCompressor>
{
	static CCAB CabCompressor::makeCabParams(
		boost::filesystem::wpath const &cab_path,
		enum FileNameEncoding encoding)
	{
		CCAB cab_params;
		// size available for cabinet on this media
		/*
		 * When a CAB file reaches this size, a new CAB will be created
		 * automatically.  This is useful for fitting CAB files onto disks.
		 *
		 * If you want to create just one huge CAB file with everything in
		 * it, change this to a very very large number.
		 */
		cab_params.cb = CB_MAX_DISK;    // Maximum size of cabinet
		// Thresshold for forcing a new Folder
		/*
		 * When a folder has this much compressed data inside it,
		 * automatically flush the folder.
		 *
		 * Flushing the folder hurts compression a little bit, but
		 * helps random access significantly.
		 */
		cab_params.cbFolderThresh = 50000000;
		// Don't reserve space for any extensions
		//  Space to reserve in CFHEADER
		cab_params.cbReserveCFHeader = 0;
		//  Space to reserve in CFFOLDER
		cab_params.cbReserveCFFolder = 0;
		//  Space to reserve in CFDATA
		cab_params.cbReserveCFData   = 0;
		// sequential numbers for cabinets
		// We use this to create the cabinet name
		cab_params.iCab = 1;
		// Disk number
		// If you want to use disk names, use this to count disks
		cab_params.iDisk = 0;
		// Cabinet set ID
		// Choose your own number
		cab_params.setID = 0;
		// current disk name
		/*
		 * Only important if CABs are spanning multiple
		 * disks, in which case you will want to use a
		 * real disk name.
		 *
		 * Can be left as an empty string.
		 */
		//::lstrcpynA(cab_params.szDisk, "MyDisk", CB_MAX_DISK_NAME);
#if defined(_MSC_VER) && (_MSC_VER >= 1400) /* VC 2005 */
		::strncpy_s(cab_params.szDisk, "MyDisk", _TRUNCATE);
#else /* others */
#error Not implemented
#endif
		// current cabinet name
		/* store name of first CAB file */
		std::wstring const file_title = cab_path.filename();
		//LPCTSTR filename_ptr = ::PathFindFileName(cab_path);
		const Encoding enc(encoding);
		int ret1 = enc.convertToCabEncoding(
			file_title.c_str(), cab_params.szCab, CB_MAX_CABINET_NAME);
		if (ret1 != 0) {
			//throw StdCError(ret1);
			throw MY_STD_C_EXCEPTION(ret1);
		}
		// path for creating cabinet
		/* where to store the created CAB files */
		boost::filesystem::wpath cab_dir_path = cab_path;
		cab_dir_path.remove_filename();
		//std::wstring::size_type cab_dir_path_length = filename_ptr - cab_path;
		//std::wstring cab_dir_path(cab_path, cab_dir_path_length);
		int ret2 = enc.convertToCabEncoding(
			cab_dir_path.string().c_str(), cab_params.szCabPath, CB_MAX_CAB_PATH);
		if (ret2 != 0) {
			throw MY_STD_C_EXCEPTION(ret2);
		}

		return cab_params;
	}

public:
	CabCompressor(
		boost::filesystem::wpath const &cab_path,     // "C:\Temp"
		enum FileNameEncoding encoding = SJIS)     // t@C̃GR[h`
	: CabCompressorT<CabCompressor>(makeCabParams(cab_path, encoding), encoding)
	{
	}
};
};  // namespace MyLib

#endif  // CAB_COMPRESSOR_H__73F4CB54_B21D_42CB_A11A_1DC23235990C__INCLUDED
