#pragma once

//#include "CabDecompressor.h"

typedef void (WINAPI* MYFREEFUNC)(void *lpBuff);
extern MYFREEFUNC MyFree;

namespace MyLib {
// gq̏I肪'_''$'ɂȂĂꍇlAۂ̃t@C擾
// kԂ擾
class FileCompressionInfo
{
public:
	FileCompressionInfo(boost::filesystem::wpath const &file_path)
	: original_filename_(file_path.filename())
	, compression_type_(0)
	{
		wchar_t *actual_file_path;
		DWORD source_file_size, target_file_size;
		unsigned int compression_type;
		DWORD ret = ::SetupGetFileCompressionInfo(file_path.string().c_str(),
		                                          &actual_file_path,
		                                          &source_file_size,
		                                          &target_file_size,
		                                          &compression_type);
		if (ret == NO_ERROR) {
			this->actual_path_ = actual_file_path;
			MyFree(actual_file_path);
			this->compression_type_ = compression_type;
		}
	}

	bool exists() const
	{
		return !this->actual_path_.empty();
	}

	// FILE_COMPRESSION_NONE or FILE_COMPRESSION_WINLZA or FILE_COMPRESSION_MSZIP
	unsigned int getCompressionType() const
	{
		assert(this->exists());
		return this->compression_type_;
	}

	boost::filesystem::wpath getActualPath() const
	{
		assert(this->exists());
		return this->actual_path_;
	}

	boost::filesystem::wpath decompressOrCopyFile(boost::filesystem::wpath const &dir_path) const
	{
		// t@C𓀂(kĂȂꍇAPɃRs[)
		assert(this->exists());
		namespace fs = boost::filesystem;

		fs::create_directories(dir_path);
		fs::wpath const dst_path = dir_path/this->original_filename_;
		std::wstring const src_path_str = this->actual_path_.string();
		std::wstring const dst_path_str = dst_path.string();
		unsigned int compression_type = this->compression_type_;
		DWORD ret = ::SetupDecompressOrCopyFile(src_path_str.c_str(),
		                                        dst_path_str.c_str(),
		                                        &compression_type);
		if (ret != NO_ERROR) {
			throw MY_SETUP_API_FILE_TRANSFER_EXCEPTION(src_path_str, dst_path_str, ret);
		}
		return dst_path;
	}

private:
	std::wstring original_filename_;
	boost::filesystem::wpath actual_path_;
	unsigned int compression_type_;
};
};  // namespace MyLib
