#ifndef FUNCTION_H__DCC6E951_D561_480C_BB84_AD4177B11711__INCLUDED
#define FUNCTION_H__DCC6E951_D561_480C_BB84_AD4177B11711__INCLUDED
// M$ compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/////////////////////////////////////////////////////////////////////////////
// function.h
//  pCuW
//  H19(2007)/12/11 쐬
//  H20(2008)/02/25 u啶EʂȂ̔r֐vǉ
//  H21(2009)/06/03 AutoHandle Ɨ
//                  compareStringNoCase() ̃oO(Ƃ "a"  "abc" vƂ݂Ȃ)C
//  H21(2009)/06/06 boost ̓ɔAȉ폜
//                    createDirectoryPath()
//                    TemporaryBuffer
//                    PathString
/////////////////////////////////////////////////////////////////////////////

//#include <tchar.h>
//#include <sstream>
//#include <algorithm>
//#include <functional>
//#include <stdexcept>
#include "exception.h"

namespace MyLib {
// 萔16ił킵Ƃ̌߂
// gp@:
//  IntFigure<0xFF>::value == 2
template <unsigned N>
struct IntHexFigure {
	enum { value = IntHexFigure<N/16>::value + 1 };
};
template<>
struct IntHexFigure<0> {
	enum { value = 0 };
};

inline size_t convertUTF16ToUTF8(const wchar_t *s, char *d)
{
	bool in_surrogate_pair = false;
	wchar_t high_surrogate = 0;
	size_t count = 1;
	while (*s != L'\0') {
		if (in_surrogate_pair) {
			if (IS_LOW_SURROGATE(*s)) {
				if (d != NULL) {
					uint32_t value =
						(((high_surrogate & 0x03FF) << 10) | (*s & 0x03FF))
						+ 0x010000;
					*d++ = static_cast<char>((value >> 18) | 0xF0);
					*d++ = static_cast<char>(((value >> 12) & 0x3F) | 0x80);
					*d++ = static_cast<char>(((value >> 6) & 0x3F) | 0x80);
					*d++ = static_cast<char>((value & 0x3F) | 0x80);
				}
				count += 4;
			} else {
				break;
			}
			in_surrogate_pair = false;
		} else {
			if (0x0000 <= *s && *s <= 0x007F) {
				if (d != NULL) {
					*d++ = static_cast<char>(*s);
				}
				count += 1;
			} else if (0x0080 <= *s && *s <= 0x07FF) {
				if (d != NULL) {
					*d++ = static_cast<char>(((*s >> 6) & 0x1F) | 0xC0);
					*d++ = static_cast<char>((*s & 0x3F) | 0x80);
				}
				count += 2;
			} else if (IS_HIGH_SURROGATE(*s)) {
				in_surrogate_pair = true;
				high_surrogate = *s;
			} else if (IS_LOW_SURROGATE(*s)) {
				break;
			} else if (0x0800 <= *s && *s <= 0xFFFF) {
				if (d != NULL) {
					*d++ = static_cast<char>((*s >> 12) | 0xE0);
					*d++ = static_cast<char>(((*s >> 6) & 0x3F) | 0x80);
					*d++ = static_cast<char>((*s & 0x3F) | 0x80);
				}
				count += 3;
			}
		}
		s++;
	}
	if (d != NULL) {
		*d = '\0';
	}
	return count;
}

inline std::string convertUTF16ToUTF8(const std::wstring& utf16_str)
{
	size_t n = convertUTF16ToUTF8(utf16_str.c_str(), NULL);
	char *ptr = new char[n];
	convertUTF16ToUTF8(utf16_str.c_str(), ptr);
	std::string result = ptr;
	delete[] ptr;
	return result;
}

inline size_t convertUTF8ToUTF16(const char *s, wchar_t *d)
{
	size_t count = 1;
	int flag = 0;
	uint32_t tmp = 0;
	while (*s != '\0') {
		unsigned char c = *s;
		if (flag == 0) {
			if ((c & 0xF8) == 0xF0) {	// 5byte11110
				flag = 3;
				tmp = static_cast<uint32_t>((c & 0x07)) << 18;
			} else if ((c & 0xF0) == 0xE0) {	// 4byte1110
				flag = 2;
				tmp = static_cast<uint32_t>((c & 0x0F)) << 12;
			} else if ((c & 0xE0) == 0xC0) {	// 3byte110
				flag = 1;
				tmp = static_cast<uint32_t>((c & 0x1F)) << 6;
			} else if ((c & 0x80) == 0) {	// 1byte0
				if (d != NULL) {
					*d++ = c;
				}
				++count;
			} else {
				break;
			}
		} else if (flag == 1) {
			flag = 0;
			if (tmp <= 0xFFFF) {
				if (d != NULL) {
					*d++ = static_cast<wchar_t>(tmp | (c & 0x3F));
				}
				++count;
			} else {
				if (d != NULL) {
					tmp |= (c & 0x3F);
					tmp -= 0x00010000;
					*d++ = static_cast<wchar_t>(((tmp >> 10) & 0x03FF) | HIGH_SURROGATE_START);
					*d++ = static_cast<wchar_t>((tmp & 0x03FF) | LOW_SURROGATE_START);
				}
				count += 2;
			}
		} else {
			--flag;
			tmp |= static_cast<uint32_t>((c & 0x3F)) << (flag*6);
		}
		s++;
	}
	if (d != NULL) {
		*d = L'\0';
	}
	return count;
}

inline std::wstring convertUTF8ToUTF16(const std::string& utf8_str)
{
	size_t n = convertUTF8ToUTF16(utf8_str.c_str(), NULL);
	wchar_t *ptr = new wchar_t[n];
	convertUTF8ToUTF16(utf8_str.c_str(), ptr);
	std::wstring result = ptr;
	delete[] ptr;
	return result;
}

//=======================================================================
// for_each ̈ȗev[g֐
// [http://homepage2.nifty.com/well/for_each.html]q
//=======================================================================
template <typename T_container, typename T_function>
T_function forEach(T_container& container, T_function function) {
	return std::for_each(container.begin(), container.end(), function);
}

//=======================================================================
// 啶EʂȂ̔r֐
//=======================================================================
inline int compareStringNoCase(std::wstring const &left, std::wstring const &right)
{
	// lstrcmpi()ECompareString()gȂ̂́A
	// 啶E𓯈ꎋt@C̋KƈقȂ邽߁B
	// [http://d.hatena.ne.jp/hasegawayosuke/20060125/1138185283]
	// tolower()gȂ̂́A}`oCgɑΉ邽߁B

	// ׂ̕đ啶ɂ
	size_t left_buf_count = left.length() + 1;
	boost::scoped_array<wchar_t> left_buf(new wchar_t[left_buf_count]);
	std::memcpy(left_buf.get(), left.c_str(), left_buf_count*sizeof(wchar_t));
	::CharUpper(left_buf.get());
	// ׂ̕đ啶ɂ
	size_t right_buf_count = right.length() + 1;
	boost::scoped_array<wchar_t> right_buf(new wchar_t[right_buf_count]);
	std::memcpy(right_buf.get(), right.c_str(), right_buf_count*sizeof(wchar_t));
	::CharUpper(right_buf.get());
	// r
	size_t const comp_size = std::min(left_buf_count, right_buf_count)*sizeof(wchar_t);
	int const result = std::memcmp(&left_buf[0], &right_buf[0], comp_size);
	if (result == 0) {
		if (left_buf_count > right_buf_count) {
			return 1;
		}
		if (left_buf_count < right_buf_count) {
			return -1;
		}
	}
	return result;
}
//   //=======================================================================
//   // 啶EʂȂ̔r֐
////=======================================================================
//   inline int compareStringNoCase(const std::wstring& left, const std::wstring& right)
//   {
//       // lstrcmpi()ECompareString()gȂ̂́A
//       // 啶E𓯈ꎋt@C̋KƈقȂ邽߁B
//       // [http://d.hatena.ne.jp/hasegawayosuke/20060125/1138185283]
//       // tolower()gȂ̂́A}`oCgɑΉ邽߁B

//       // ׂ̕đ啶ɂ
//       size_t left_buf_count = left.length() + 1;
//       std::vector<TCHAR> left_buf(left_buf_count);
//       ::memcpy(&left_buf[0], left.c_str(), left_buf_count*sizeof(TCHAR));
//       ::CharUpper(&left_buf[0]);
//       // ׂ̕đ啶ɂ
//       size_t right_buf_count = right.length() + 1;
//       std::vector<TCHAR> right_buf(right_buf_count);
//       ::memcpy(&right_buf[0], right.c_str(), right_buf_count*sizeof(TCHAR));
//       ::CharUpper(&right_buf[0]);
//       // r
//       size_t comp_size = std::min(left_buf_count, right_buf_count)*sizeof(TCHAR);
//       return ::memcmp(&left_buf[0], &right_buf[0], comp_size);
//   }

//=======================================================================
// 啶EʂȂ̔r֐IuWFNg
//=======================================================================
struct LessNoCase
	: public std::binary_function<std::wstring, std::wstring, bool>
{
	bool operator()(const std::wstring& _Left, const std::wstring& _Right) const
	{	// apply operator> to operands
		return compareStringNoCase(_Left, _Right) < 0;
	}
};

//=======================================================================
// UTF-8ɕϊ(zev[g)
//=======================================================================
inline int convertToUTF8(LPCTSTR src, LPSTR dest, size_t dest_size)
{
#ifdef UNICODE
	int result_code = 0;
	const int ret = ::WideCharToMultiByte(CP_UTF8, 0, src, -1, dest,
		static_cast<int>(dest_size), NULL, NULL);
	if (ret == 0) {
		switch (::GetLastError()) {
			case ERROR_INSUFFICIENT_BUFFER:
				result_code = ERANGE;
				break;
			//case ERROR_INVALID_PARAMETER:
			//case ERROR_INVALID_FLAGS:
			default:
				result_code = EINVAL;
				break;
		}
	}
#else
#error Not implemented
#endif
	return result_code;
}
//=======================================================================
// UTF-8ɕϊ(std::string)
//=======================================================================
inline std::string convertToUTF8(const std::wstring& str)
{
#ifdef UNICODE
	std::string result;
	const int required_size = ::WideCharToMultiByte(CP_UTF8, 0,
		str.c_str(), -1, NULL, 0, NULL, NULL);
	if (required_size > 0) {
		std::vector<char> buf(required_size);
		const int ret = ::WideCharToMultiByte(CP_UTF8, 0,
			str.c_str(), -1, &buf[0], required_size, NULL, NULL);
		if (ret == 0) {
			switch (::GetLastError()) {
				case ERROR_INSUFFICIENT_BUFFER:
					//throw StdCError(ERANGE);
					throw MY_STD_C_EXCEPTION(ERANGE);
				//case ERROR_INVALID_PARAMETER:
				//case ERROR_INVALID_FLAGS:
				default:
					//throw StdCError(EINVAL);
					throw MY_STD_C_EXCEPTION(EINVAL);
			}
		} else {
			result = &buf[0];
		}
	} else {
		switch (::GetLastError()) {
			case ERROR_INSUFFICIENT_BUFFER:
				//throw StdCError(ERANGE);
				throw MY_STD_C_EXCEPTION(ERANGE);
			//case ERROR_INVALID_PARAMETER:
			//case ERROR_INVALID_FLAGS:
			default:
				//throw StdCError(EINVAL);
				throw MY_STD_C_EXCEPTION(EINVAL);
		}
	}
	return result;
#else
#error Not implemented
#endif
}

//=======================================================================
// ShiftJIS(CP932)ɕϊ(zev[g)
//=======================================================================
inline int convertToSJIS(LPCTSTR src, LPSTR dest, size_t dest_size)
{
#ifdef UNICODE
	int result_code = 0;
	BOOL is_default_char_used;
	const int ret = ::WideCharToMultiByte(CP_ACP, WC_NO_BEST_FIT_CHARS,
		src, -1, dest, static_cast<int>(dest_size), NULL, &is_default_char_used);
	if (ret == 0) {
		switch (::GetLastError()) {
			case ERROR_INSUFFICIENT_BUFFER:
				result_code = ERANGE;
				break;
			//case ERROR_INVALID_PARAMETER:
			//case ERROR_INVALID_FLAGS:
			default:
				result_code = EINVAL;
				break;
		}
	} else if (is_default_char_used) {
		result_code = EILSEQ;
	}
#else
#error Not implemented
#endif
	return result_code;
}
//=======================================================================
// ShiftJIS(CP932)ɕϊ(std::string)
//=======================================================================
inline std::string convertToSJIS(const std::wstring& str)
{
#ifdef UNICODE
	std::string result;
	const int required_size = ::WideCharToMultiByte(CP_ACP,
		WC_NO_BEST_FIT_CHARS, str.c_str(), -1, NULL, 0, NULL, NULL);
	if (required_size > 0) {
		std::vector<char> buf(required_size);
		BOOL is_default_char_used;
		const int ret = ::WideCharToMultiByte(CP_ACP, WC_NO_BEST_FIT_CHARS,
			str.c_str(), -1, &buf[0], required_size, NULL, &is_default_char_used);
		if (ret == 0) {
			const uint32_t err_code = ::GetLastError();
			switch (err_code) {
				case ERROR_INSUFFICIENT_BUFFER:
					//throw StdCError(ERANGE);
					throw MY_STD_C_EXCEPTION(ERANGE);
				//case ERROR_INVALID_PARAMETER:
				//case ERROR_INVALID_FLAGS:
				default:
					//throw StdCError(EINVAL);
					throw MY_STD_C_EXCEPTION(EINVAL);
			}
		} else if (is_default_char_used) {
			//throw StdCError(EILSEQ);
			throw MY_STD_C_EXCEPTION(EILSEQ);
		} else {
			result = &buf[0];
		}
	} else {
		switch (::GetLastError()) {
			case ERROR_INSUFFICIENT_BUFFER:
				//throw StdCError(ERANGE);
				throw MY_STD_C_EXCEPTION(ERANGE);
			//case ERROR_INVALID_PARAMETER:
			//case ERROR_INVALID_FLAGS:
			default:
				//throw StdCError(EINVAL);
				throw MY_STD_C_EXCEPTION(EINVAL);
		}
	}
	return result;
#else
#error Not implemented
#endif
}

inline std::wstring convertFromUTF8(const std::string& str)
{
	std::wstring result;
#ifdef UNICODE
	const int required_size = ::MultiByteToWideChar(CP_UTF8, 0, str.c_str(),
		-1, NULL, 0);
	if (required_size > 0) {
		std::vector<TCHAR> buf(required_size);
		const int ret = ::MultiByteToWideChar(
			CP_UTF8, 0, str.c_str(), -1, &buf[0], required_size);
		if (ret == 0) {
			switch (::GetLastError()) {
				case ERROR_INSUFFICIENT_BUFFER:
					//throw StdCError(ERANGE);
					throw MY_STD_C_EXCEPTION(ERANGE);
				//case ERROR_INVALID_PARAMETER:
				//case ERROR_INVALID_FLAGS:
				default:
					//throw StdCError(EINVAL);
					throw MY_STD_C_EXCEPTION(EINVAL);
			}
		}
		result = &buf[0];
	}
#else
#error Not implemented
#endif
	return result;
}

inline std::wstring convertFromSJIS(const std::string& str)
{
	std::wstring result;
#ifdef UNICODE
	const int required_size = ::MultiByteToWideChar(
		CP_ACP, MB_ERR_INVALID_CHARS, str.c_str(), -1, NULL, 0);
	if (required_size > 0) {
		std::vector<TCHAR> buf(required_size);
		const int ret = ::MultiByteToWideChar(
			CP_ACP, 0, str.c_str(), -1, &buf[0], required_size);
		if (ret == 0) {
			switch (::GetLastError()) {
				case ERROR_INSUFFICIENT_BUFFER:
					//throw StdCError(ERANGE);
					throw MY_STD_C_EXCEPTION(ERANGE);
				//case ERROR_INVALID_PARAMETER:
				//case ERROR_INVALID_FLAGS:
				default:
					//throw StdCError(EINVAL);
					throw MY_STD_C_EXCEPTION(EINVAL);
			}
		}
		result = &buf[0];
	}
#else
#error Not implemented
#endif
	return result;
}

////=======================================================================
//// fBNgKw쐬
//// WAPIɁAMakeSureDirectoryPathExists()ASHCreateDirectory()A
//// SHPathPrepareForWrite()Ȃǂ̂́AǂCɓȂߍ쐬
////=======================================================================
//inline int createDirectoryPath(const std::wstring& dir_path)
//{
//    size_t path_length = dir_path.length();
//    std::vector<TCHAR> buf(path_length + 1);
//    for (size_t i = 0; i < path_length; ++i) {
//        buf[i] = dir_path[i];
//        if (buf[i] == _T('\\') || i == path_length - 1) {
//            buf[i + 1] = _T('\0');
//            // ꖼ̂̃fBNg݂Ȃ΍쐬
//            uint32_t attribs = ::GetFileAttributes(&buf.front());
//            if (attribs == ~0 || (attribs & FILE_ATTRIBUTE_DIRECTORY) == 0) {
//                if (!::CreateDirectory(&buf.front(), NULL)) {
//                    return ::GetLastError();
//                }
//            }
//        }
//    }
//    return NO_ERROR;
//}

//=======================================================================
// ꎞt@CƂĎgpłt@C𐶐
//=======================================================================
inline boost::filesystem::wpath createTemporaryFilePath(boost::filesystem::wpath const &dir_path)
{
	namespace fs = boost::filesystem;
	// obt@̊m
	const size_t buf_count = IntHexFigure<UINT_MAX>::value*2 + 4 + 1;
	boost::scoped_array<wchar_t> buf(new wchar_t[buf_count]);
	// vZXID擾
	static uint32_t *process_id = NULL;
	if (process_id == NULL) {
		process_id = new uint32_t;
		*process_id = ::GetCurrentProcessId();
		::srand(::GetTickCount());
	}
	fs::wpath result;
	do {
		// 𐶐
#if defined(_MSC_VER) && (_MSC_VER >= 1400) /* VC 2005 */
		::_stprintf_s(
			buf.get(), buf_count,
			_T("%x%x.tmp"), *process_id, ::rand());
#else /* others */
#error Not implemented
#endif
		result = dir_path/buf.get();
	} while (fs::exists(result));
	return result;
}

inline boost::filesystem::wpath createTemporaryFilePath()
{
	// TemptH_̃pX󂯎̂ɕKvȃobt@TCY擾
	DWORD const temp_path_count = ::GetTempPath(0, NULL);
	if (temp_path_count == 0) {
		throw MY_WIN32_EXCEPTION_LAST_ERROR;
	}
	boost::scoped_array<wchar_t> buf(new wchar_t[temp_path_count]);
	::GetTempPath(temp_path_count, buf.get());
	return MyLib::createTemporaryFilePath(boost::filesystem::wpath(buf.get()));
}

// t@C(ǂ݂ƂpO)݉\ɂ
inline int toFileWritable(boost::filesystem::wpath const &file_path)
{
	//// t@C̑擾
	//uint32_t attribs = ::GetFileAttributes(file_path.string().c_str());
	//if (attribs == 0xFFFFFFFF) {
	//	return ERROR_FILE_NOT_FOUND;
	//}
	//// ǂ݂ƂptĂO
	//if (attribs & FILE_ATTRIBUTE_READONLY) {
		//attribs &= ~FILE_ATTRIBUTE_READONLY;
		DWORD attribs =  FILE_ATTRIBUTE_NORMAL;
		if (!::SetFileAttributes(file_path.string().c_str(), attribs)) {
			return ::GetLastError();
		}
	//}
	return NO_ERROR;
}

////=======================================================================
//// std::auto_ptr HANDLE
////=======================================================================
//template <HANDLE INVALID>
//class AutoHandle
//{
//public:
//    /*explicit*/ AutoHandle(HANDLE h = INVALID) : h_(h) {}

//    AutoHandle(AutoHandle& right) : h_(right.release()) {}

//    ~AutoHandle() { this->close(); }

//    HANDLE get() const { return this->h_; }

//    HANDLE release()
//    {
//        HANDLE temp = this->h_;
//        this->h_ = INVALID;
//        return temp;
//    }

//    void reset(HANDLE h = INVALID)
//    {
//        if (this->h_ != h) {
//            this->close();
//            this->h_ = h;
//        }
//    }

//    AutoHandle& operator=(AutoHandle& right)
//    {
//        this->reset(right.release());
//        return *this;
//    };

//    bool isInvalid() const { return this->h_ == INVALID; }

//private:
//    HANDLE h_;

//    void close()
//    {
//        if (this->h_ != INVALID) {
//            ::CloseHandle(this->h_);
//            this->h_ = INVALID;
//        }
//    }
//};

////=======================================================================
//// ꎞobt@
////=======================================================================
//template <class T>
//class TemporaryBuffer
//{
//public:
//    explicit TemporaryBuffer(size_t n)
//        : buf_ptr(NULL), buf_count(n)
//    { buf_ptr = new T[n]; }

//    ~TemporaryBuffer() { delete[] buf_ptr; }

//    T* getPointer() const { return this->buf_ptr; }
//    // zvf̌Ԃ
//    size_t getCount() const { return this->buf_count; }
//    // z̃oCgPʂ̃TCYԂ
//    size_t getSize() const { return this->buf_count*sizeof(T); }

//private:
//    T *buf_ptr;
//    const size_t buf_count;
//};

////=======================================================================
//// Œ蒷Allocator
////=======================================================================
//template <class T, size_t BUF_SIZE>
//class FixedAllocator
//    : public std::allocator<T>
//{	// generic allocator for objects of class _Ty
//public:
//    // v[
//    T buf[BUF_SIZE];

   // template <class U>
   // struct rebind
   // {	// convert an allocator<_Ty> to an allocator <_Other>
	  //  typedef FixedAllocator<U, BUF_SIZE> other;
   // };

   // void deallocate(pointer /*_Ptr*/, size_type)
   // {	// deallocate object at _Ptr, ignore size
   // }

   // pointer allocate(size_type /*_Count*/)
   // {	// allocate array of _Count elements
//        return (pointer)buf;
   // }

   // pointer allocate(size_type _Count, const void _FARQ *)
   // {	// allocate array of _Count elements, ignore hint
	  //  return (allocate(_Count));
   // }

   // size_t max_size() const
   // {	// estimate maximum array size
//        return BUF_SIZE;
   // }
//};

//    //=======================================================================
//    // PathString
//    //=======================================================================
//    class PathString
//    {
//    public:
//        PathString()
//        {
//        }
//
//        PathString(const MyLib::std::wstring& path)
//        {
//	        const size_t buf_size = ::GetFullPathName(path.c_str(), 0, NULL, NULL);
//			if (buf_size > 0) {
//				TemporaryBuffer<TCHAR> buf(buf_size);
//				::GetFullPathName(
//					path.c_str(), static_cast<DWORD>(buf_size), buf.getPointer(), NULL);
//				this->path_str = buf.getPointer();
//			}
//        }
//
//        bool exists() const { return ::PathFileExists(this->path_str.c_str()) != FALSE; }
//
//        PathString operator+(const MyLib::std::wstring& s1) const
//        {
//            TemporaryBuffer<TCHAR> buf(this->path_str.length() + 1 + s1.length() + 1);
//#if defined(_MSC_VER) && (_MSC_VER >= 1400) /* VC 2005 */
//			::_tcscpy_s(buf.getPointer(), buf.getCount(), this->path_str.c_str());
//#else
//            ::_tcscpy(buf.getPointer(), this->path_str.c_str());
//#endif
//            ::PathAppend(buf.getPointer(), s1.c_str());
//            return PathString(buf.getPointer());
//        }
//
//        const std::wstring& str() const { return this->path_str; }
//
//        void removeFileSpec()
//        {
//            TemporaryBuffer<TCHAR> buf(this->path_str.length() + 1);
//#if defined(_MSC_VER) && (_MSC_VER >= 1400) /* VC 2005 */
//			::_tcscpy_s(buf.getPointer(), buf.getCount(), this->path_str.c_str());
//#else
//            ::_tcscpy(buf.getPointer(), this->path_str.c_str());
//#endif
//            ::PathRemoveFileSpec(buf.getPointer());
//            this->path_str = buf.getPointer();
//        }
//
//		// 4/24 updated!!
//		bool isDirectory() const
//		{
//			return ::PathIsDirectory(this->path_str.c_str()) != 0;
//		}
//
//		// 4/24 updated!!
//		void renameExtension(const std::wstring& new_extension)
//		{
//			TemporaryBuffer<TCHAR> buf(this->path_str.length() + new_extension.length());
//#if defined(_MSC_VER) && (_MSC_VER >= 1400) /* VC 2005 */
//			::_tcscpy_s(buf.getPointer(), buf.getCount(), this->path_str.c_str());
//#else
//            ::_tcscpy(buf.getPointer(), this->path_str.c_str());
//#endif
//			::PathRenameExtension(buf.getPointer(), new_extension.c_str());
//			this->path_str = buf.getPointer();
//		}
//
//    private:
//        MyLib::std::wstring path_str;
//    };
};

#endif // FUNCTION_H__DCC6E951_D561_480C_BB84_AD4177B11711__INCLUDED
