#pragma once

//#include "autohandle.h"
//#include "exception.h"

namespace MyLib {
class StorageDeviceNumber :
	private STORAGE_DEVICE_NUMBER
{
public:
	StorageDeviceNumber(wchar_t drive_letter)
	{
		wchar_t buf[] = L"\\\\.\\A:";
		buf[4] = drive_letter;

		HANDLE h = ::CreateFile(buf,
		                        0,
		                        FILE_SHARE_READ | FILE_SHARE_WRITE,
		                        NULL,
		                        OPEN_EXISTING,
		                        FILE_ATTRIBUTE_NORMAL,
		                        NULL);
		AutoHandle<INVALID_HANDLE_VALUE> ah(h);
		if (ah.isInvalid()) {
			throw MyLib::Win32FileException(buf);
		}

		STORAGE_DEVICE_NUMBER sdn;
		DWORD junk;
		BOOL ret = ::DeviceIoControl(ah.get(),
		                             IOCTL_STORAGE_GET_DEVICE_NUMBER,
		                             NULL,
		                             0,
		                             &sdn,
		                             sizeof(sdn),
		                             &junk,
		                             NULL);
		if (!ret) {
			throw MyLib::Win32FileException(buf);
		}

		*(reinterpret_cast<STORAGE_DEVICE_NUMBER*>(this)) = sdn;
	}

	unsigned int getDeviceType() const
	{
		return this->DeviceType;
	}

	unsigned int getDeviceNumber() const
	{
		return this->DeviceNumber;
	}

	unsigned int getPartitionNumber() const
	{
		return this->PartitionNumber;
	}
};
};  // namespace MyLib
