#include <assert.h>
#include <tchar.h>
#include <windows.h>

#define WINNT_INF_FILENAME L"\\$winnt$.inf"
#define PRESETUP_CMD_PATH L"\\$OEM$\\Drivers"

//#define DEBUG001
#ifdef DEBUG001
	HANDLE hfile;
	DWORD dww;
#endif

extern DWORD WINAPI ThreadProc(void *param);
/*
 * _~[ SETUP.EXE
 *	SETUP.EXEu邱ƂɂAGUIZbgAbvJnOɔCӂ̏
 *	sł悤ɂB
 *	̓e̓CXg[CD$OEMDRV$fBNgɂpresetup.cmdɋLqB
 */

void appendPath(wchar_t * path1, wchar_t const * path2);
wchar_t* findFileNameFromPath(wchar_t const *path);
BOOL executeCommand(wchar_t *cmd_line);

DWORD WINAPI ThreadProc(void *param)
{
	wchar_t **argv;
	int argc;
	unsigned int winnt_inf_path_buf_size;
	wchar_t *winnt_inf_path;
	unsigned int source_path_buf_size;
	wchar_t *source_path;
	unsigned int n;
	unsigned int presetup_cmd_path_len;
	wchar_t * filename_ptr;
	wchar_t setup_exe_path[MAX_PATH];
	wchar_t setuporg_exe_path[MAX_PATH];
	int i;
	HKEY reg_key;
	DWORD reg_type, reg_data_size;
	LPTSTR f6tool_device_path;
	HWND hwnd = (HWND)param;

	/* R}hCo */
	argv = CommandLineToArgvW(GetCommandLine(), &argc);

	/* %SystemRoot%\system32\$winnt$.inf pX̍쐬 */
	winnt_inf_path_buf_size = GetSystemDirectory(NULL, 0);
	winnt_inf_path_buf_size += (unsigned int)wcslen(WINNT_INF_FILENAME);
	winnt_inf_path = (wchar_t*)HeapAlloc(GetProcessHeap(),
	                                     HEAP_ZERO_MEMORY,
	                                     winnt_inf_path_buf_size*sizeof(wchar_t));
	GetSystemDirectory(winnt_inf_path, winnt_inf_path_buf_size);
	lstrcat(winnt_inf_path, WINNT_INF_FILENAME);


	presetup_cmd_path_len = (unsigned int)wcslen(PRESETUP_CMD_PATH);

	/* $winnt$.inf [data]ZNVsourcepathL[̒l擾 */
	source_path_buf_size = MAX_PATH + presetup_cmd_path_len;
	source_path = (wchar_t*)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, source_path_buf_size*sizeof(wchar_t));
	n = GetPrivateProfileString(L"data",
	                            L"sourcepath",
	                            L"",
	                            source_path,
	                            source_path_buf_size -presetup_cmd_path_len,
	                            winnt_inf_path);
	while (n == source_path_buf_size - presetup_cmd_path_len - 1) {
		source_path_buf_size *= 2;
		source_path = (wchar_t*)HeapReAlloc(GetProcessHeap(),
		                                    HEAP_ZERO_MEMORY,
		                                    source_path,
		                                    source_path_buf_size*sizeof(wchar_t));
		n = GetPrivateProfileString(L"data",
		                            L"sourcepath",
		                            L"",
		                            source_path,
		                            source_path_buf_size - presetup_cmd_path_len,
		                            winnt_inf_path);
	}

	HeapFree(GetProcessHeap(), 0, winnt_inf_path);

	/* sourcepath ɃR}hCA */
	appendPath(source_path, /*argv[1]*/PRESETUP_CMD_PATH);

	RegOpenKeyEx(HKEY_LOCAL_MACHINE,
		_T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion"), 0, KEY_ALL_ACCESS, &reg_key);
	/* hCopfBNghCuɊ蓖Ă */
	RegQueryValueEx(reg_key, _T("F6ToolDevicePath"), 0, &reg_type, NULL, &reg_data_size);
	f6tool_device_path = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, reg_data_size);
	RegQueryValueEx(reg_key, _T("F6ToolDevicePath"), 0, &reg_type, (BYTE*)f6tool_device_path, &reg_data_size);
	RegCloseKey(reg_key);
	DefineDosDevice(DDD_RAW_TARGET_PATH, f6tool_device_path, source_path);
#ifdef DEBUG001
	hfile = CreateFile(L"C:\\setup_exe.log", GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	WriteFile(hfile, "\xFF\xFE", 2, &dww, NULL);
	CloseHandle(hfile);
#endif
	GetModuleFileName(NULL, setup_exe_path, MAX_PATH);
	/* {SETUP.EXEN */
	lstrcpy(setuporg_exe_path, setup_exe_path);
	filename_ptr = findFileNameFromPath(setuporg_exe_path);
	lstrcpy(filename_ptr, L"setupold.exe");

	MoveFile(setup_exe_path, setuporg_exe_path);
	lstrcpy(filename_ptr, L"setuporg.exe");
	MoveFile(setuporg_exe_path, setup_exe_path);

	for (i = 1; i < argc; ++i) {
		lstrcat(setup_exe_path, L" \"");
		lstrcat(setup_exe_path, argv[i]);
		lstrcat(setup_exe_path, L"\"");
	}
#ifdef DEBUG001
	hfile = CreateFile(L"C:\\setup_exe2.log", GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	WriteFile(hfile, "\xFF\xFE", 2, &dww, NULL);
#endif
	executeCommand(setup_exe_path);

	HeapFree(GetProcessHeap(), 0, f6tool_device_path);
	HeapFree(GetProcessHeap(), 0, source_path);

#ifdef DEBUG001
	WriteFile(hfile, L"test\r\n", 12, &dww, NULL);
	CloseHandle(hfile);
#endif
	PostMessage(hwnd, WM_CLOSE, 0, 0);
	return 0;
}

/* pX path1  path2 A */
void appendPath(wchar_t * path1, wchar_t const * path2)
{
	int const path1_len = lstrlen(path1);
	if (path1_len > 0 && lstrlen(path2) > 0) {
		if (path1[path1_len - 1] == L'\\' && path2[0] == L'\\') {
			path1[path1_len - 1] = L'\0';
		} else if (path1[path1_len - 1] != L'\\' && path2[0] != L'\\') {
			lstrcat(path1, L"\\");
		}
	}
	lstrcat(path1, path2);
}

/* pX񂩂At@C̊Jn|C^Ԃ */
wchar_t* findFileNameFromPath(wchar_t const *path)
{
	wchar_t const *ptr;
	int const path_len = lstrlen(path);

	if (path_len <= 0) {
		return (wchar_t*)path;
	}
	
	for (ptr = path + lstrlen(path) - 1; ptr > path; ptr = CharPrev(path, ptr)) {
		if (*ptr == L'\\') {
			return (wchar_t*)(ptr + 1);
		}
	}
	return (wchar_t*)ptr;
}

BOOL executeCommand(wchar_t *cmd_line)
{
	/*SECURITY_ATTRIBUTES security_attribs;*/
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	BOOL ret;

	/*security_attribs.nLength = sizeof(SECURITY_ATTRIBUTES);
	security_attribs.lpSecurityDescriptor = NULL;
	security_attribs.bInheritHandle = TRUE;*/
	/* Get ready to spawn the batch file we just created. */
	si.cb = sizeof(STARTUPINFO);
	si.lpReserved = NULL;
	si.lpDesktop = NULL;
	si.lpTitle = NULL;
	si.cbReserved2 = 0;
	si.lpReserved2 = NULL;
	/* We want its console window to be invisible to the user. */
	si.dwFlags = /*STARTF_USESHOWWINDOW*/0;
	/*si.wShowWindow = SW_HIDE;*/
	/* presetup.cmd̋N */
	/*ret = CreateProcess(NULL, cmd_line, &security_attribs,
		&security_attribs, TRUE, 0, NULL, NULL, &si, &pi);*/
	ret = CreateProcess(NULL, cmd_line, NULL,
		NULL, FALSE, 0, NULL, NULL, &si, &pi);
	if (ret) {
		CloseHandle(pi.hThread);
		/* presetup.cmd̏I҂ */
		WaitForSingleObject(pi.hProcess, INFINITE);
		CloseHandle(pi.hProcess);
#ifdef DEBUG001
	} else {
		wchar_t buf[64];
		DWORD err = GetLastError();
		wsprintf(buf, L"CreateProcess returned %d\r\n", err);
		WriteFile(hfile, buf, lstrlen(buf)*sizeof(wchar_t), &dww, NULL);
#endif
	}
	return ret;
}
